@ECHO OFF
CLS
ECHO Ŀ
ECHO  FiveWin for Harbour 1.0                 Harbour development power          
ECHO  (c) FiveTech, 1993-2001      for Microsoft Windows 95/98/NT/2000/ME and XP 
ECHO 
ECHO  

if A%1 == A GOTO :SINTAX
if NOT EXIST %1.prg GOTO :NOEXIST
if NOT EXIST ..\lib\SBrowseH.lib GOTO :NOLIB

ECHO Compiling...

c:\harbour\bin\harbour %1 /n  /ic:\Fwh\include;c:\harbour\include > comp.log
c:\borland\bcc55\bin\bcc32 -D__HARBOUR__;HB_API_MACROS -O2 -c -Ic:\harbour\include;c:\fwh\include %1.c >> comp.log

IF ERRORLEVEL 1 GOTO COMPILERROR
ECHO c:\borland\bcc55\Lib\c0w32.obj + > Buildh.lnk
ECHO %1.obj + >> Buildh.lnk
ECHO ..\obj\FwCalenH.obj, + >> Buildh.lnk
ECHO %1.exe,, + >> Buildh.lnk
ECHO ..\lib\SBrowseH.lib c:\fwh\lib\FiveH.lib c:\fwh\lib\FiveHC.lib + >> Buildh.lnk
ECHO c:\harbour\lib\rtl.lib + >> Buildh.lnk
ECHO c:\harbour\lib\vm.lib + >> Buildh.lnk
ECHO c:\harbour\lib\gtwin.lib + >> Buildh.lnk
ECHO c:\harbour\lib\rdd.lib + >> Buildh.lnk
ECHO c:\harbour\lib\lang.lib + >> Buildh.lnk
ECHO c:\harbour\lib\macro.lib + >> Buildh.lnk
rem uncomment the next two lines to use Advantage RDD
rem ECHO c:\harbour\lib\Ace32.lib + >> Buildh.lnk
rem ECHO c:\harbour\lib\rddads.lib + >> Buildh.lnk
ECHO c:\harbour\lib\dbfntx.lib + >> Buildh.lnk
ECHO c:\harbour\lib\dbfcdx.lib + >> Buildh.lnk
ECHO c:\harbour\lib\debug.lib +  >> Buildh.lnk
ECHO c:\harbour\lib\common.lib + >> Buildh.lnk
ECHO c:\harbour\lib\pp.lib + >> Buildh.lnk
ECHO c:\borland\bcc55\lib\cw32.lib + >> Buildh.lnk


IF NOT EXIST %1.rc GOTO NORESOURCES
c:\borland\bcc55\bin\brc32 -r %1 >> Comp.log
ECHO c:\borland\bcc55\lib\import32.lib,, + >> Buildh.lnk
ECHO %1.res >> Buildh.lnk

IF ERRORLEVEL 1 GOTO COMPILERROR
GOTO LINK

:NORESOURCES
ECHO c:\borland\bcc55\lib\import32.lib  >> Buildh.lnk
IF ERRORLEVEL 1 GOTO LINKERROR

:LINK
c:\borland\bcc55\bin\ilink32 -Gn -aa -Tpe -s @Buildh.lnk > link.log

rem deleting temporary files
@del *.c
@del *.obj
@del *.res
@del *.map
@del *.tds
@del Buildh.lnk

ECHO * Applicacion construida exitosamente
ECHO * Application successfully built
%1.exe
GOTO EXIT
ECHO

:LINKERROR
ECHO Linkinkg error, see Link.log file
ECHO Errores en linkado, ve el archivo Link.log
GOTO EXIT

:SINTAX
ECHO    SYNTAX: Build [Program]     {-- No especifiques la extensin PRG
ECHO                                {-- Don't specify .PRG extension
GOTO EXIT

:NOEXIST
ECHO The specified PRG %1 does not exist
ECHO El PRG %1 especificado no existe
GOTO EXIT

:NOLIB
ECHO First, you need to build the library SBROWSEH.LIB
ECHO Debes construir antes la libreria SBROWSEH.LIB
PAUSE
GOTO EXIT

:COMPILERROR
ECHO Compilating error, see Comp.log file
ECHO Error en la compilacion, ve el archivo Comp.log

:EXIT
