* Class TSBrowse, Test program.
* Author: Manuel Mercado Gmez.
* Freelance programmer.
* Salamanca, Gto., Mxico.
* mmercadog@prodigy.net.mx
* January 21th, 2002

#define _VIDEO_CH
#define _DDE_CH

#include "TSBrowse.ch"
#include "FiveWin.ch"

// uncomment the next line for using ADS/Harbour RDD
//#include "ADS.ch"

#define CLR_PINK   nRGB( 255, 128, 128)
#define CLR_NBLUE  nRGB( 128, 128, 192)
#define CLR_NBROWN  nRGB( 130, 99, 53)
#define CLR_1 nRGB( 190, 215, 190 )
#define CLR_2 nRGB( 230, 230, 230 )
#define CLR_3 nRGB( 217, 217, 255 )

/* SBTest.prg uses Clipper-Harbour DBFNTX RDD by default, to use other RDD,
   uncomment the proper lines of the following ones */

// uncomment the next line for Clipper-Harbour DBFCDX RDD
//REQUEST DBFCDX

// uncomment the next line for Harbour Advantage RDD
//REQUEST _ADS, ADSKeyno, ADSKeycount

// uncomment one of the next two lines for Clipper Advantage RDD
//REQUEST DBFCDXAX, AX_KeyNo, AX_KeyCount, AX_SetScope
//REQUEST DBFNTXAX, AX_KeyNo, AX_KeyCount, AX_SetScope

// uncomment the next line for Clipper COMIX RDD
//REQUEST COMIX, cmxKeyNo, cmxKeyCount, cmxKeyGoTo, cmxSetScope

// uncomment the next line for Clipper COMIX+ClipMore RDD
//REQUEST COMIX, cmKeyNo, cmKeyCount, cmKeyGoTo, cmSetScope

Static oWnd, oIco, aWChild, aFont[ 4 ], aBrush[ 7 ]

//---------------------------------------------------------------------------------------//

Function Main()

   Local oBmp,  oBar, cTitle, oBtn[ 9 ], aColor[ 2 ], ;
         lNoBlink := .F.

   Field First, Last, Married, Age, Salary, State 

   /* uncomment the proper lines of the following ones, according to the RDD
      you are using */

   /* The following lines are required for Harbour ADS RDD */
//   RddRegister( "ADS", 1 )      // ADS for Harbour
//   RddSetDefault( "ADS" )       // ADS for Harbour
//   SET SERVER LOCAL             // ADS for Harbour Local Server
//   SET FILETYPE TO CDX          // ADS for Harbour CDX file type OR
//   SET FILETYPE TO NTX          // ADS for Harbour NTX file type

   /* For other RDD's */
//   RddSetDefault( "COMIX" )
//   RddSetDefault( "DBFNTX" )    // Clipper-Harbour 
//   RddSetDefault( "DBFCDX" )    // Clipper-Harbour
//   RddSetDefault( "DBFCDXAX" )  // ADS for Clipper OR
//   RddSetDefault( "DBFNTXAX" )  // ADS for Clipper


   cTitle := "TSBrowse ! The Power of Columns ! "

   USE States ALIAS Sta SHARED NEW
   Index On State To States       // NTX
//   Index On State Tag States      // CDX

   USE Employee SHARED NEW
   Index On First+Last To Name    // NTX
//   Index On First+Last Tag Name   // CDX
   Index On State To State        // NTX
//   Index On State Tag State       // CDX
   Set Index To Name, State       // NTX
//   OrdSetFocus( "Name" )          // CDX

   aWChild := Array( 8 )

   SET _3DLOOK ON

   If ( aColor[ 1 ] := GetSysColor( COLOR_INACTIVECAPTION ) ) != ;
      GetSysColor( COLOR_ACTIVECAPTION )
      aColor[ 2 ] := GetSysColor( COLOR_INACTCAPTEXT ) 
      lNoBlink := .T.
      SBNoBlink()
   Endif

   DEFINE BITMAP oBmp RESOURCE "Cover" OF oWnd
   DEFINE ICON oIco RESOURCE "SuperBrw"

   DEFINE WINDOW oWnd TITLE cTitle ;
          COLORS CLR_BLACK, CLR_BLUE ;
          MENU BuildMenu() MENUINFO 2;
          ICON oIco MDI

   DEFINE BUTTONBAR oBar OF oWnd SIZE 25,25 _3D  

   DEFINE BUTTON oBtn[ 1 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 1 ], 1) ;
          NOBORDER TOOLTIP "Sample 1"
   DEFINE BUTTON oBtn[ 2 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 2 ], 2) ;
          NOBORDER TOOLTIP "Sample 2"
   DEFINE BUTTON oBtn[ 3 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 3 ], 3) ;
          NOBORDER TOOLTIP "Sample 3"
   DEFINE BUTTON oBtn[ 4 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 4 ], 4) ;
          NOBORDER TOOLTIP "Sample 4"
   DEFINE BUTTON oBtn[ 5 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 5 ], 5) ;
          NOBORDER TOOLTIP "Sample 5"
   DEFINE BUTTON oBtn[ 6 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 6 ], 6) ;
          NOBORDER TOOLTIP "Sample 6"
   DEFINE BUTTON oBtn[ 7 ] RESOURCE "Super16" OF oBar ;
          ACTION MenuSample( oBtn[ 7 ], 7) ;
          NOBORDER TOOLTIP "Sample 7"
   DEFINE BUTTON oBtn[ 8 ] RESOURCE "Super16" OF oBar ;
          ACTION fFolder() ;
          NOBORDER TOOLTIP "Samples en Folder"
   DEFINE BUTTON oBtn[ 9 ] RESOURCE "ExitB16" OF oBar ;
          ACTION oWnd:End() ;
          NOBORDER TOOLTIP "Exit"

   DEFINE FONT aFont[ 1 ] NAME "Arial" SIZE 0, -12
   aFont[ 2 ] := TFont():New( "Wingdings", 0, -18,, .T.,,,,.F.,.F.,.F., 1 )
   DEFINE FONT aFont[ 3 ] NAME "MS Sans Serif" SIZE 0, -9
   DEFINE FONT aFont[ 4 ] NAME "Arial" SIZE 0, -14 BOLD ITALIC

   // let's define brushes for new textures in browses
   DEFINE BRUSH aBrush[ 1 ] RESOURCE "WPaper"
   DEFINE BRUSH aBrush[ 2 ] RESOURCE "Wall"
   DEFINE BRUSH aBrush[ 3 ] RESOURCE "Wood"
   DEFINE BRUSH aBrush[ 4 ] RESOURCE "Grass"
   DEFINE BRUSH aBrush[ 5 ] RESOURCE "Orchid"
   DEFINE BRUSH aBrush[ 6 ] RESOURCE "Bricks"
   DEFINE BRUSH aBrush[ 7 ] RESOURCE "Parquet"


   SET MESSAGE OF oWnd CLOCK DATE KEYBOARD NOINSET

   If "FWH" $ FWVERSION .or. "FiveWin 2.2" $ FWVERSION .or. "FiveWin 2.3" $ FWVERSION
      ACTIVATE WINDOW oWnd MAXIMIZED ;
               ON PAINT DrawBitmap( hDC, oBmp:hBitMap, ;
                        ( oWnd:nHeight() / 2 ) - ( oBmp:nHeight() / 2 ) - 50, ;
                        ( oWnd:nWidth() / 2 ) - ( oBmp:nWidth() / 2 ) ) ;
               VALID ( If( lNoBlink, SBNoBlink( aColor[ 1 ], aColor[ 2 ] ), ;
                          Nil ), AEval( aFont, { |o| o:End() } ), .T. )

   Else
      ACTIVATE WINDOW oWnd MAXIMIZED ;
               ON PAINT DrawBitmap( hDC, oBmp:hBmpPal, ;
                        ( oWnd:nHeight() / 2 ) - ( oBmp:nHeight() / 2 ) - 50, ;
                        ( oWnd:nWidth() / 2 ) - ( oBmp:nWidth() / 2 ) ) ;
               VALID ( If( lNoBlink, SBNoBlink( aColor[ 1 ], aColor[ 2 ] ), ;
                          Nil ), AEval( aFont, { |o| o:End() } ), .T. )
   EndIf

   DbCloseAll()
   
   AEval( aBrush, { |b| b:End() } )

   Release Objects oIco, oBmp

Return nil

//---------------------------------------------------------------------------------------//

Function BuildMenu()

   Local oMenu

   MENU oMenu
      MENUITEM "TSBrowse"
         MENU
            MENUITEM "Samples on Dialogs"
               MENU
                  MENUITEM "Sample 1" ;
                    ACTION fDialog( 1 )
                  MENUITEM "Sample 2" ;
                    ACTION fDialog( 2 )
                  MENUITEM "Sample 3" ;
                    ACTION fDialog( 3 )
                  MENUITEM "Sample 4" ;
                    ACTION fDialog( 4 )
                  MENUITEM "Sample 5" ;
                    ACTION fDialog( 5 )
                  MENUITEM "Sample 6" ;
                    ACTION fDialog( 6 )
                  MENUITEM "Sample 7" ;
                    ACTION fDialog( 7 )
               ENDMENU
            MENUITEM "Samples on Windows"
               MENU
                  MENUITEM "Sample 1" ;
                    ACTION fWindow( 1 )
                  MENUITEM "Sample 2" ;
                    ACTION fWindow( 2 )
                  MENUITEM "Sample 3" ;
                    ACTION fWindow( 3 )
                  MENUITEM "Sample 4" ;
                    ACTION fWindow( 4 )
                  MENUITEM "Sample 5" ;
                    ACTION fWindow( 5 )
                  MENUITEM "Sample 6" ;
                    ACTION fWindow( 6 )
                  MENUITEM "Sample 7" ;
                    ACTION fWindow( 7 )
               ENDMENU
            MENUITEM "Samples on Folder" ;
               ACTION fFolder()
        ENDMENU
      MENUITEM "&Window"
         MENU
         ENDMENU
      MENUITEM "&Exit" ACTION oWnd:End()
      MENUITEM "&Help" ACTION WinExec( "Start ..\doc\Help.htm", 0 )
   ENDMENU

Return oMenu

//--------------------------------------------------------------------------//

Static Function MenuSample( oBtn, nSample )

   LOCAL oMenu

   MENU oMenu POPUP
        MENUITEM "&Dialog" RESOURCE "Point" ;
                 ACTION fDialog( nSample )
        MENUITEM "&Window" RESOURCE "Point" ;
                 ACTION fWindow( nSample )
   ENDMENU

   ACTIVATE POPUP oMenu AT oBtn:nBottom - 1 , 0 OF oBtn

RETURN Nil

//---------------------------------------------------------------------------------------//

Static Function fDialog( nSample )

   Local oDlg, oBar, oFld, oBmp, oBrw[ 7 ], oCol, aRect, nEle, ;
         nMarried  := 0, ;
         nSingle := 0, ;
         nTotSal  := 0, ;
         nAgeTot  := 0, ;
         nOldAge  := 0, ;
         nOldSal  := 0, ;
         aStates := {}

   Field First, Last, Married, Age, Salary, State

   DEFINE BITMAP oBmp RESOURCE "Head"
   DEFINE DIALOG oDlg RESOURCE "DIALOG_1"

   DO Case


      Case nSample = 1

   REDEFINE BROWSE oBrw[ 1 ] COLORS CLR_BLACK, CLR_NBLUE ALIAS "Employee" ;
            ID 110 OF oDlg FONT aFont[ 1 ] ;
            MESSAGE "Cell height idependent of the font size using oBrw:nHeightCell. " +;
                    "Also try multi-select feature by double clicking."

      oBrw[ 1 ]:LoadFields( .F. )

      oBrw[ 1 ]:SetColor( { 1, 3, 5, 6, 13, 15 }, ;
                          { CLR_BLACK, CLR_WHITE, CLR_BLACK, ;
                            { CLR_WHITE, CLR_BLACK }, ; // degraded cursor background color
                            CLR_WHITE, CLR_BLACK } )  // text colors
      oBrw[ 1 ]:SetColor( { 2, 4, 14 }, ;
                          { { CLR_WHITE, CLR_NBLUE }, ;  // degraded cells background color
                            { CLR_WHITE, CLR_BLACK }, ;  // degraded headers backgroud color
                            { CLR_HRED, CLR_BLACK } } )  // degraded order column background color

      oBrw[ 1 ]:nHeightCell += 6
      oBrw[ 1 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 1 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // vertical header in columns 8 y 9
      oBrw[ 1 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 1 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 1 ]:SetColSize( 8, 25)
      oBrw[ 1 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 1 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 1 ]:aColumns[ 5 ]:cOrder := "State"

      // degraded colors look better without horizontal lines
      oBrw[ 1 ]:nLineStyle := LINES_VERT




      Case nSample = 2

   DbSelectArea( "Sta" )
   DbEval( { || AAdd(aStates, State ) } )
   DbSelectArea( "Employee" )

   REDEFINE BROWSE oBrw[ 2 ] CELLED ALIAS "Employee" ;
            ID 110 OF oDlg FONT aFont[ 1 ] ;
            MESSAGE "Auto-Append pressing down arrow at last row using" + ;
                    "::SetAppendMode( .T. )"

     oBrw[ 2 ]:LoadFields( .T. )
     oBrw[ 2 ]:nFreeze := 1
     oBrw[ 2 ]:SetAppendMode( .T. )

     // flagging columns that affect index key to issue UpStable() when fields change
     oBrw[ 2 ]:SetIndexCols( 1, 2 )

     oBrw[ 2 ]:Look3d( .T., , , .F. )  // ( lOnOff, nColumn, nLevel, lPhantomGrid )

     oBrw[ 2 ]:SetColor( { 1, 2, 3, 4, 5, 6, 15 }, ;
                         { CLR_WHITE, aBrush[ 4 ], CLR_WHITE, aBrush[ 5 ], ;
                           CLR_BLACK, nRGB( 236, 160, 19 ), CLR_BLACK } )

     // changing colors to column 2
     oBrw[ 2 ]:SetColor( { 1, 2 }, { CLR_BLACK, CLR_WHITE }, 2 )

     oBrw[ 2 ]:InsColumn( 8, OClone( oBrw[ 2 ]:aColumns[ 8 ] ) )

     // Windings font for happy/unhappy face
     oBrw[ 2 ]:aColumns[ 9 ]:bData := { | x | If( Married, "L", "J" ) }

     // avoid edition of column 9
     oBrw[ 2 ]:aColumns[ 9 ]:lEdit := .F.

     // we don't want empty names
     oBrw[ 2 ]:aColumns[ 1 ]:bValid := { | uVar | ! Empty( uVar ) }
     oBrw[ 2 ]:aColumns[ 2 ]:bValid := { | uVar | ! Empty( uVar ) }

     // Changing alignment to cells of columns 8 and 9
     oBrw[ 2 ]:SetAlign( 8, 1, DT_CENTER )   // ( nCol, nLevel, nAlign )
     oBrw[ 2 ]:SetAlign( 9, 1, DT_CENTER )   // nLevel 1=Cell, 2=Header, 3=Footer

     // now, setting a font to a single column
     oBrw[ 2 ]:ChangeFont( aFont[ 2 ], 9, 1 )   // 9 = column  1 = Nivel Celdas

     // next, setting colors at cell level for columns 9, 10 and 11
     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Married, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 9 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Age > 60, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 10 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                           { || If( Salary > 50000,CLR_HGREEN, ;
                                If( Salary > 10000,CLR_HRED, ;
                                    CLR_RED ) ) }, ;
                           CLR_WHITE, CLR_BLACK }, 11 )

     // setting bData and related table for showing the combobox use at column 4
     oBrw[ 2 ]:SetData( 5, FieldWBlock( "State", Select() ), aStates )

     // changing the width of columns 5 and 7 to fit the ComboBox and the BtnGet
     oBrw[ 2 ]:SetColSize( 5, 130 )  // SetColSize( nColumn, nWidth )
     oBrw[ 2 ]:SetColSize( 7, 85 )

     // now changing the width of columns 8, 9 and 10 to fit new font
     oBrw[ 2 ]:SetColSize( { 8, 9, 10 }, { 55, 55, 40 } )  // ( aColumn, aWidth )

     // setting font aFont[ 4 ] to every header
     oBrw[ 2 ]:ChangeFont( aFont[ 4 ],,2 )  // ( aFont[ 1 ], nCol, nLevel )

     // activating BtnGet to column  7
     oBrw[ 2 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                 dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                 oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )
     
     

      Case nSample = 3


   REDEFINE BROWSE oBrw[ 3 ] ALIAS "Employee" ;
      ID 110 OF oDlg ;

      oBrw[ 3 ]:LoadFields()

      oBrw[ 3 ]:SetColor( { 1, 3, 5, 13 }, { CLR_BLACK, CLR_BLACK, CLR_BLACK, ;
                                             CLR_BLACK } )

      // new degraded colors and brushed background
      oBrw[ 3 ]:SetColor( { 2, 4, 6, 12, 14 }, { aBrush[ 1 ], ;  // brushed cells
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded headers
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded cursor
                          { CLR_HRED, CLR_BLACK }, ;    // degraded selected cells
                          { CLR_HGREEN, CLR_BLACK } } ) // degraded active index header

      oBrw[ 3 ]:nHeightCell += 6
      oBrw[ 3 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 3 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // brushing browse background
      oBrw[ 3 ]:oBrush := aBrush[ 1 ]

      // vertical header in columns 8 y 9
      oBrw[ 3 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 3 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 3 ]:SetColSize( 8, 25)
      oBrw[ 3 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 3 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 3 ]:aColumns[ 5 ]:cOrder := "State"

      // 3D text raised in all levels and all columns
      oBrw[ 3 ]:Set3DText( .T., .T. )




      Case nSample = 4

   DbEval( { || nAgeTot += Age } )
   DbGotop()

   REDEFINE BROWSE oBrw[ 4 ] GRID  ALIAS "Employee" ;
            COLORS CLR_BLACK,CLR_PINK ;
            ID 110 OF oDlg FONT aFont[ 1 ] ;
            MESSAGE "Fonts, colors and bitmaps different for cells, headers and footers"

      ADD COLUMN TO oBrw[ 4 ];
          HEADER  oBmp ;
          SIZE 130 ;
          DATA FieldWBlock( "First", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          ALIGN DT_LEFT, DT_CENTER ;
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Last" + CRLF + "Name" ;  // multi-line feature on headers
          DATA FieldWblock( "Last", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE ;
          ALIGN DT_LEFT, DT_LEFT, DT_RIGHT ;
          FOOTER "Average->" ;
          EDITABLE MOVE DT_MOVE_RIGHT

      // next column shows the Vertical Header and Check Box editing control
      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Married" ;
          SIZE 25 PIXELS ; 
          DATA FieldWblock( "Married", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          3DLOOK TRUE CHECKBOX ;          // Editing with Check Box
          ALIGN DT_CENTER, DT_VERT ;      // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Age" ;
          SIZE 32 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Age", Select() ) ;
          COLORS CLR_BLACK, CLR_PINK ;
          FOOTER { || Ltrim( Str( Round( nAgeTot / oBrw[ 4 ]:nLen, 0 ) ) ) + CRLF + ;
                      "Years" } ;  // multi-line feature on footers
          ALIGN DT_CENTER, DT_VERT ;  // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT 

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Salary" ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Salary", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          ALIGN DT_RIGHT ;  // defaults right alignment at 3 levels
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Hire" + CRLF + "Date" ;   // multi-line feature on headers
          SIZE 85 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Hiredate", Select() ) ;
          ALIGN DT_LEFT, DT_CENTER, DT_CENTER ;
          COLORS CLR_BLACK,CLR_PINK ;
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Address" ;
          SIZE 270 PIXELS ;
          3DLOOK TRUE ;
          DATA { || oBrw[ 4 ]:Proper( Employee->Street ) + CRLF + ;
                    Trim( Employee->Zip ) + Space( 1 ) + ;
                    oBrw[ 4 ]:Proper( Trim( Employee->City ) ) + ", " + ;
                    State } ;  // multi-line feature on cells
          COLORS CLR_BLACK,CLR_PINK

      oBrw[ 4 ]:lNoHScroll := .T.
      oBrw[ 4 ]:nHeightCell += 2
      oBrw[ 4 ]:nHeightHead += 3

      // setting font to column 2 at all levels (Nil)
      oBrw[ 4 ]:ChangeFont( aFont[ 4 ], 2, Nil )  // (aFont[ 1 ], nColumn, nLevel)

      oBrw[ 4 ]:SetColor({ 5, 6 },{ CLR_WHITE, CLR_BLACK } ) // cursor background
      oBrw[ 4 ]:SetColor({ 5 },{ CLR_RED }, 2 )  // cursor background column 2
      oBrw[ 4 ]:aColumns[ 2 ]:cMsg := "A different font for each column."

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 4 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column 5
      oBrw[ 4 ]:SetBtnGet( 6, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      // managing var value for footing of column 3
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 4 ]:aColumns[ 4 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldAge := uVal, .T. ) }
      oBrw[ 4 ]:aColumns[ 4 ]:bPostEdit := ;
                { | uVal | nAgeTot += ( uVal - nOldAge ), ;
                           If( oBrw[ 4 ]:lChanged, oBrw[ 4 ]:DrawFooters(), ) }

      // 3D text bas-relief in all headers
      oBrw[ 4 ]:Set3DText( .T., .F.,, 2 )

      // 3D text raised in cells of column 2
      oBrw[ 4 ]:Set3DText( .T., .T., 2, 1 )



      Case nSample = 5


   REDEFINE BROWSE oBrw[ 5 ] COLORS CLR_BLACK,CLR_YELLOW ;
            ID 110 OF oDlg ;
            MESSAGE "oBrw:lNoHScroll, eliminates horizontal scroll bar."

      // Setting the text file for viewing
      oBrw[ 5 ]:SetTxtFile( "TSBrowse.ch", ;
                            "TSBrowse Text Viewer" )

      // we don't want any cursor
      oBrw[ 5 ]:lNoLiteBar := .T.

      // we don't want horizontal scroll bar
      oBrw[ 5 ]:lNoHScroll := .T.

      // neither grid lines
      oBrw[ 5 ]:nLineStyle := LINES_NONE

      // setting font aFont[ 1 ] to every header
      oBrw[ 5 ]:ChangeFont( aFont[ 1 ],, 2 )  // ChangeFont( aFont[ 1 ], nColumn, nLevel ) 
                                         // nLevel 1 = Cells 2= Headers  3 = Footers

      // brushing cells background
      oBrw[ 5 ]:SetColor( { 2, 4 }, { aBrush[ 7 ], aBrush[ 3 ] } )

      // brushing browse background
      oBrw[ 5 ]:oBrush := aBrush[ 7 ]

      oBrw[ 5 ]:nHeightCell := 20




      Case nSample = 6

   DbSelectArea( "Sta" )
   DbEval( { || AAdd(aStates, State ) } )
   DbSelectArea( "Employee" )

   REDEFINE BROWSE oBrw[ 6 ]  GRID ALIAS "Employee" ;
      ID 110 OF oDlg ;
      MESSAGE "oBrw:LoadFields(), creates columns for every field in the active DB."

      oBrw[ 6 ]:LoadFields( .T. )
      oBrw[ 6 ]:nLineStyle := LINES_DOTTED 
      oBrw[ 6 ]:nHeightCell += 6
      oBrw[ 6 ]:nHeightHead += 4
      oBrw[ 6 ]:SetColor( { 2, 3, 4, 5, 6, 15 }, ;
                          { { || If( oBrw[ 6 ]:nLogicPos % 2 = 0, ;
                             aBrush[ 2 ], aBrush[ 1 ] ) }, ; // brushed cells
                           CLR_BLACK, aBrush[ 6 ], ; // brushed headers
                           CLR_WHITE, { CLR_WHITE, CLR_BLACK }, ; // degraded cursor
                           CLR_GRAY } )  // grid lines color

      // activating continuous editing mode
      oBrw[ 6 ]:lAutoEdit := .T.

      // interchanging positions between columns 4 and 5
      oBrw[ 6 ]:Exchange( 4, 5 )

      // changing the width of columns 4 and 7 to fit the ComboBox and the BtnGet
      oBrw[ 6 ]:SetColSize( 4, 130 )  // ( nColumn, nWidth )
      oBrw[ 6 ]:SetColSize( 7, 80 )

      // setting bData and related table for showing the combobox use at column 4
      oBrw[ 6 ]:SetData( 4, FieldWBlock( "State", Select() ), aStates )

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 6 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column  7
      oBrw[ 6 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      oBrw[ 6 ]:nLineStyle := LINES_VERT

      // 3D text raised in all headers, special colors for 3D effect
      oBrw[ 6 ]:Set3DText( .T., .T.,, 2, CLR_YELLOW, CLR_RED )

      // all headers centered
      oBrw[ 6 ]:SetAlign( , 2, DT_CENTER )

      // vertical header in column 9
      oBrw[ 6 ]:SetAlign( 9, 2, DT_VERT )

      // adjust the header height
      oBrw[ 6 ]:nHeightHead := 25



      Case nSample = 7

   DbEval( { || If( Married, ++nMarried, ++nSingle ), nTotSal += Salary } )
   DbGotop()

   REDEFINE BROWSE oBrw[ 7 ] CELLED ALIAS "Employee" ;
      ID 110 OF oDlg ;
      FONT aFont[ 1 ]

      ADD COLUMN TO oBrw[ 7 ] ;
          HEADER "Index" ;
          DATA   oBrw[ 7 ]:nLogicPos ;
          SIZE 40 PIXELS ;
          FOOTER LTrim( Str( oBrw[ 7 ]:nLen ) ) ;
          3DLOOK TRUE,TRUE,FALSE ;  // cels, header, footer
          ALIGN DT_CENTER,DT_CENTER,DT_CENTER ;   // cells, header, footer
          COLORS CLR_BLACK, CLR_HGRAY

      // building columns for every field making each editable (.T.)
      oBrw[ 7 ]:LoadFields( .T. )

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_WHITE, CLR_GRAY } )    // footers
      oBrw[ 7 ]:SetColor( { 5, 6, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             CLR_BLACK } )        // grid lines

      oBrw[ 7 ]:SetColor( { CLR_EDITF, CLR_EDITB }, { CLR_BLACK, CLR_HGRAY } )  // Edicion

      // activating footers
      oBrw[ 7 ]:lFooting := .T.

      // freezing up to column 2
      oBrw[ 7 ]:nFreeze := 2

      // blocking frozen columns
      oBrw[ 7 ]:lLockFreeze := .T.

      // avoid edition of columns 2 and 3
      oBrw[ 7 ]:aColumns[ 2 ]:lEdit := .F.
      oBrw[ 7 ]:aColumns[ 3 ]:lEdit := .F.

      // changing colors to a single cell
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_WHITE, { || If( Married, ;        
                           CLR_HRED, CLR_NBLUE ) } }, 9 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_BLACK, ;
                          { || If( Age >= 60, ;
                           CLR_HRED, CLR_HGREEN ) } }, 10 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                                     { || If( Salary > 50000,CLR_HGREEN, ;
                                         If( Salary > 10000,CLR_HRED, ;
                                             CLR_RED ) ) } }, 11 )

      // changing background color of cells of column 12
      oBrw[ 7 ]:SetColor( { 2 }, { { CLR_YELLOW, CLR_BLACK } }, 12 ) // degraded color

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_BLACK, aBrush[ 2 ] } )  // brushed Footers

      oBrw[ 7 ]:SetColor( { 5, 6, 4, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             aBrush[ 2 ], ; // brushed headers background
                                             CLR_BLACK } )  // grid lines

      // setting footers to columns 2, 8, 9, 11 y 12 using multi-line feature
      oBrw[ 7 ]:aColumns[ 2 ]:cFooting := "<-Total" + CRLF + "   Records"
      oBrw[ 7 ]:aColumns[ 8 ]:cFooting := "Married->" + CRLF + "Single->"
      oBrw[ 7 ]:Acolumns[ 9 ]:cFooting := { || LTrim( Str( nMarried ) ) + " T" + CRLF + ;
                                               LTrim( Str( nSingle ) ) + " F"}
      oBrw[ 7 ]:Acolumns[ 11 ]:cFooting := { || LTrim( Transform( nTotSal, ;
                                                "$##,###,###" ) ) }
      oBrw[ 7 ]:Acolumns[ 12 ]:cFooting := "<--Look at the font size."

      // changing footer font of column 11
      oBrw[ 7 ]:ChangeFont( aFont[ 3 ], 11, 3 )  // 3 = footer

      // centering text of column 9, all levels
      oBrw[ 7 ]:SetAlign( 9, , DT_CENTER )  // SetAlign( nColumn, nLevel, nAlign )

      // calculating vars value for footings
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 7 ]:aColumns[ 9 ]:bPostEdit := ;
                { | uVal | If( oBrw[ 7 ]:lChanged, ;
                           ( If( uVal, ( --nSingle, ++nMarried ), ;
                                     ( ++nSingle, --nMarried ) ), ;
                                       oBrw[ 7 ]:DrawFooters() ), ) }

      oBrw[ 7 ]:aColumns[ 11 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldSal := uVal, .T. ) }
      oBrw[ 7 ]:aColumns[ 11 ]:bPostEdit := ;
                { | uVal | nTotSal += ( uVal - nOldSal ), ;
                           If( oBrw[ 7 ]:lChanged, oBrw[ 7 ]:DrawFooters(), ) }
                         
      // changing header colors of columns from 8 to 11
      For nEle := 9 TO 11
         oBrw[ 7 ]:SetColor( { 3, 4 }, { CLR_WHITE, CLR_GRAY }, nEle )
      Next   

      // increasing cells height
      oBrw[ 7 ]:nHeightCell += 3

      // changing headings to columns 3 and 8 using multi-line
      oBrw[ 7 ]:aColumns[ 3 ]:cHeading := "Last" + CRLF + "Name"
      oBrw[ 7 ]:aColumns[ 8 ]:cHeading := "Hire" + CRLF + "Date"

      // another fancy use of BtnGet (Combo Browse)
      oBrw[ 7 ]:SetBtnGet( 6, "Help16", { | oGet, cVar | ;
                 aRect := GetCoors( oGet:hWnd ), cVar := oGet:Value(), ;
                 cVar := ComboBrowse( cVar, aRect[ 1 ], aRect[ 4 ], oGet:oWnd ), ;
                 oGet:cText( cVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      // editing message for column 6
      oBrw[ 7 ]:aColumns[ 6 ]:cMsg := "Press F2 or Click button to see the list"


   EndCase

   //  oBrw:ShowSizes() una buena herramienta para los programadores
   oBrw[ nSample ]:bRClicked := { || oBrw[ nSample ]:ShowSizes() }

   REDEFINE BUTTON ID 210 OF oDlg ACTION oDlg:End()

   ACTIVATE DIALOG oDlg CENTERED ;
            ON PAINT oMsg := TMsgBar():New( oDlg, ;
                             "TSBrowse El poder de las columnas." ) ;
            VALID ( oBmp:End(), .T. )

Return Nil

//---------------------------------------------------------------------------------------//

Static Function fFolder()

   Local oDlg, oBar, oFld, oBmp, oBrw[ 7 ], oCol, aRect, nEle, ;
         nMarried  := 0, ;
         nSingle := 0, ;
         nTotSal  := 0, ;
         nAgeTot  := 0, ;
         nOldAge  := 0, ;
         nOldSal  := 0, ;
         aStates := {}

   Field First, Last, Married, Age, Salary, State

   DbSelectArea( "Sta" )
   DbEval( { || AAdd(aStates, State ) } )
   DbSelectArea( "Employee" )

   DbEval( { || nAgeTot += Age } )
   DbGotop()

   DEFINE BITMAP oBmp RESOURCE "Head"

   DEFINE DIALOG oDlg RESOURCE "Test"

   REDEFINE FOLDER oFld ID 110 OF oDlg ;
      PROMPTS "Multi Selection", "Auto Append", "Color Code Blocks", ;
              "Multi Line/ChecBox", "Text Viewer", "Auto Edit", "Footers/BtnGet" ;
      DIALOGS "One", "One", "One", "One", "One", "One", "One"

   REDEFINE BROWSE oBrw[ 1 ]  ALIAS "Employee" ;
      COLORS CLR_BLACK, CLR_NBLUE ;
      ID 110 OF oFld:aDialogs[ 1 ] ;
      FONT aFont[ 1 ]

      oBrw[ 1 ]:LoadFields( .F. )

      oBrw[ 1 ]:SetColor( { 1, 3, 5, 6, 13, 15 }, ;
                          { CLR_BLACK, CLR_WHITE, CLR_BLACK, ;
                            { CLR_WHITE, CLR_BLACK }, ; // degraded cursor background color
                            CLR_WHITE, CLR_BLACK } )  // text colors
      oBrw[ 1 ]:SetColor( { 2, 4, 14 }, ;
                          { { CLR_WHITE, CLR_NBLUE }, ;  // degraded cells background color
                            { CLR_WHITE, CLR_BLACK }, ;  // degraded headers backgroud color
                            { CLR_HRED, CLR_BLACK } } )  // degraded order column background color

      oBrw[ 1 ]:nHeightCell += 6
      oBrw[ 1 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 1 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // vertical header in columns 8 y 9
      oBrw[ 1 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 1 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 1 ]:SetColSize( 8, 25)
      oBrw[ 1 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 1 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 1 ]:aColumns[ 5 ]:cOrder := "State"

      // degraded colors look better without horizontal lines
      oBrw[ 1 ]:nLineStyle := LINES_VERT



   REDEFINE BROWSE oBrw[ 2 ] CELLED ALIAS "Employee" ;
      ID 110 OF oFld:aDialogs[ 2 ] ;
      FONT aFont[ 1 ]

     oBrw[ 2 ]:LoadFields( .T. )
     oBrw[ 2 ]:nFreeze := 1
     oBrw[ 2 ]:SetAppendMode( .T. )

     // flagging columns that affect index key to issue UpStable() when fields change
     oBrw[ 2 ]:SetIndexCols( 1, 2 )

     oBrw[ 2 ]:Look3d( .T., , , .F. )  // ( lOnOff, nColumn, nLevel, lPhantomGrid )

     oBrw[ 2 ]:SetColor( { 1, 2, 3, 4, 5, 6, 15 }, ;
                         { CLR_WHITE, aBrush[ 4 ], CLR_WHITE, aBrush[ 5 ], ;
                           CLR_BLACK, nRGB( 236, 160, 19 ), CLR_BLACK } )

     // changing colors to column 2
     oBrw[ 2 ]:SetColor( { 1, 2 }, { CLR_BLACK, CLR_WHITE }, 2 )

     oBrw[ 2 ]:InsColumn( 8, OClone( oBrw[ 2 ]:aColumns[ 8 ] ) )

     // Windings font for happy/unhappy face
     oBrw[ 2 ]:aColumns[ 9 ]:bData := { | x | If( Married, "L", "J" ) }

     // avoid edition of column 9
     oBrw[ 2 ]:aColumns[ 9 ]:lEdit := .F.

     // we don't want empty names
     oBrw[ 2 ]:aColumns[ 1 ]:bValid := { | uVar | ! Empty( uVar ) }
     oBrw[ 2 ]:aColumns[ 2 ]:bValid := { | uVar | ! Empty( uVar ) }

     // Changing alignment to cells of columns 8 and 9
     oBrw[ 2 ]:SetAlign( 8, 1, DT_CENTER )   // ( nCol, nLevel, nAlign )
     oBrw[ 2 ]:SetAlign( 9, 1, DT_CENTER )   // nLevel 1=Cell, 2=Header, 3=Footer

     // now, setting a font to a single column
     oBrw[ 2 ]:ChangeFont( aFont[ 2 ], 9, 1 )   // 9 = column  1 = Nivel Celdas

     // next, setting colors at cell level for columns 9, 10 and 11
     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Married, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 9 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Age > 60, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 10 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                           { || If( Salary > 50000,CLR_HGREEN, ;
                                If( Salary > 10000,CLR_HRED, ;
                                    CLR_RED ) ) }, ;
                           CLR_WHITE, CLR_BLACK }, 11 )

     // setting bData and related table for showing the combobox use at column 4
     oBrw[ 2 ]:SetData( 5, FieldWBlock( "State", Select() ), aStates )

     // changing the width of columns 5 and 7 to fit the ComboBox and the BtnGet
     oBrw[ 2 ]:SetColSize( 5, 130 )  // SetColSize( nColumn, nWidth )
     oBrw[ 2 ]:SetColSize( 7, 85 )

     // now changing the width of columns 8, 9 and 10 to fit new font
     oBrw[ 2 ]:SetColSize( { 8, 9, 10 }, { 55, 55, 40 } )  // ( aColumn, aWidth )

     // setting font aFont[ 4 ] to every header
     oBrw[ 2 ]:ChangeFont( aFont[ 4 ],,2 )  // ( aFont[ 1 ], nCol, nLevel )

     // activating BtnGet to column  7
     oBrw[ 2 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                 dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                 oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )
     
     

   REDEFINE BROWSE oBrw[ 3 ] ALIAS "Employee" ;
      ID 110 OF oFld:aDialogs[ 3 ]

      oBrw[ 3 ]:LoadFields()

      oBrw[ 3 ]:SetColor( { 1, 3, 5, 13 }, { CLR_BLACK, CLR_BLACK, CLR_BLACK, ;
                                             CLR_BLACK } )

      // new degraded colors and brushed background
      oBrw[ 3 ]:SetColor( { 2, 4, 6, 12, 14 }, { aBrush[ 1 ], ;  // brushed cells
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded headers
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded cursor
                          { CLR_HRED, CLR_BLACK }, ;    // degraded selected cells
                          { CLR_HGREEN, CLR_BLACK } } ) // degraded active index header

      oBrw[ 3 ]:nHeightCell += 6
      oBrw[ 3 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 3 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // brushing browse background
      oBrw[ 3 ]:oBrush := aBrush[ 1 ]

      // vertical header in columns 8 y 9
      oBrw[ 3 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 3 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 3 ]:SetColSize( 8, 25)
      oBrw[ 3 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 3 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 3 ]:aColumns[ 5 ]:cOrder := "State"

      // 3D text raised in all levels and all columns
      oBrw[ 3 ]:Set3DText( .T., .T. )




   REDEFINE BROWSE oBrw[ 4 ] GRID ALIAS "Employee" ;
            COLORS CLR_BLACK,CLR_NBLUE ;
            ID 110 OF oFld:aDialogs[ 4 ] FONT aFont[ 1 ]

      ADD COLUMN TO oBrw[ 4 ];
          HEADER  oBmp ;
          SIZE 130 ;
          DATA FieldWBlock( "First", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          ALIGN DT_LEFT, DT_CENTER ;
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Last" + CRLF + "Name" ;  // multi-line feature on headers
          DATA FieldWblock( "Last", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE ;
          ALIGN DT_LEFT, DT_LEFT, DT_RIGHT ;
          FOOTER "Average->" ;
          EDITABLE MOVE DT_MOVE_RIGHT

      // next column shows the Vertical Header and Check Box editing control
      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Married" ;
          SIZE 25 PIXELS ; 
          DATA FieldWblock( "Married", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          3DLOOK TRUE CHECKBOX ;          // Editing with Check Box
          ALIGN DT_CENTER, DT_VERT ;      // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Age" ;
          SIZE 32 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Age", Select() ) ;
          COLORS CLR_BLACK, CLR_PINK ;
          FOOTER { || Ltrim( Str( Round( nAgeTot / oBrw[ 4 ]:nLen, 0 ) ) ) + CRLF + ;
                      "Years" } ;  // multi-line feature on footers
          ALIGN DT_CENTER, DT_VERT ;  // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT 

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Salary" ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Salary", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          ALIGN DT_RIGHT ;  // defaults right alignment at 3 levels
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Hire" + CRLF + "Date" ;   // multi-line feature on headers
          SIZE 85 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Hiredate", Select() ) ;
          ALIGN DT_LEFT, DT_CENTER, DT_CENTER ;
          COLORS CLR_BLACK,CLR_PINK ;
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Address" ;
          SIZE 270 PIXELS ;
          3DLOOK TRUE ;
          DATA { || oBrw[ 4 ]:Proper( Employee->Street ) + CRLF + ;
                    Trim( Employee->Zip ) + Space( 1 ) + ;
                    oBrw[ 4 ]:Proper( Trim( Employee->City ) ) + ", " + ;
                    State } ;  // multi-line feature on cells
          COLORS CLR_BLACK,CLR_PINK

      oBrw[ 4 ]:lNoHScroll := .T.
      oBrw[ 4 ]:nHeightCell += 2
      oBrw[ 4 ]:nHeightHead += 3

      // setting font to column 2 at all levels (Nil)
      oBrw[ 4 ]:ChangeFont( aFont[ 4 ], 2, Nil )  // (aFont[ 1 ], nColumn, nLevel)

      oBrw[ 4 ]:SetColor({ 5, 6 },{ CLR_WHITE, CLR_BLACK } ) // cursor background
      oBrw[ 4 ]:SetColor({ 5 },{ CLR_RED }, 2 )  // cursor background column 2
      oBrw[ 4 ]:aColumns[ 2 ]:cMsg := "A different font for each column."

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 4 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column 5
      oBrw[ 4 ]:SetBtnGet( 6, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      // managing var value for footing of column 3
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 4 ]:aColumns[ 4 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldAge := uVal, .T. ) }
      oBrw[ 4 ]:aColumns[ 4 ]:bPostEdit := ;
                { | uVal | nAgeTot += ( uVal - nOldAge ), ;
                           If( oBrw[ 4 ]:lChanged, oBrw[ 4 ]:DrawFooters(), ) }

      // 3D text bas-relief in all headers
      oBrw[ 4 ]:Set3DText( .T., .F.,, 2 )

      // 3D text raised in cells of column 2
      oBrw[ 4 ]:Set3DText( .T., .T., 2, 1 )



   REDEFINE BROWSE oBrw[ 5 ]  COLORS CLR_BLACK,CLR_YELLOW;
      ID 110 OF oFld:aDialogs[ 5 ]

      // Setting the text file for viewing
      oBrw[ 5 ]:SetTxtFile( "TSBrowse.ch", ;
                            "TSBrowse Text Viewer" )

      // we don't want any cursor
      oBrw[ 5 ]:lNoLiteBar := .T.

      // we don't want horizontal scroll bar
      oBrw[ 5 ]:lNoHScroll := .T.

      // neither grid lines
      oBrw[ 5 ]:nLineStyle := LINES_NONE

      // setting font aFont[ 1 ] to every header
      oBrw[ 5 ]:ChangeFont( aFont[ 1 ],, 2 )  // ChangeFont( aFont[ 1 ], nColumn, nLevel ) 
                                         // nLevel 1 = Cells 2= Headers  3 = Footers

      // brushing cells background
      oBrw[ 5 ]:SetColor( { 2, 4 }, { aBrush[ 7 ], aBrush[ 3 ] } )

      // brushing browse background
      oBrw[ 5 ]:oBrush := aBrush[ 7 ]

      oBrw[ 5 ]:nHeightCell := 20




   REDEFINE BROWSE oBrw[ 6 ]  GRID ALIAS "Employee" ;
      ID 110 OF oFld:aDialogs[ 6 ]

      oBrw[ 6 ]:LoadFields( .T. )
      oBrw[ 6 ]:nLineStyle := LINES_DOTTED 
      oBrw[ 6 ]:nHeightCell += 6
      oBrw[ 6 ]:nHeightHead += 4
      oBrw[ 6 ]:SetColor( { 2, 3, 4, 5, 6, 15 }, ;
                          { { || If( oBrw[ 6 ]:nLogicPos % 2 = 0, ;
                             aBrush[ 2 ], aBrush[ 1 ] ) }, ; // brushed cells
                           CLR_BLACK, aBrush[ 6 ], ; // brushed headers
                           CLR_WHITE, { CLR_WHITE, CLR_BLACK }, ; // degraded cursor
                           CLR_GRAY } )  // grid lines color

      // activating continuous editing mode
      oBrw[ 6 ]:lAutoEdit := .T.

      // interchanging positions between columns 4 and 5
      oBrw[ 6 ]:Exchange( 4, 5 )

      // changing the width of columns 4 and 7 to fit the ComboBox and the BtnGet
      oBrw[ 6 ]:SetColSize( 4, 130 )  // ( nColumn, nWidth )
      oBrw[ 6 ]:SetColSize( 7, 80 )

      // setting bData and related table for showing the combobox use at column 4
      oBrw[ 6 ]:SetData( 4, FieldWBlock( "State", Select() ), aStates )

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 6 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column  7
      oBrw[ 6 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      oBrw[ 6 ]:nLineStyle := LINES_VERT

      // 3D text raised in all headers, special colors for 3D effect
      oBrw[ 6 ]:Set3DText( .T., .T.,, 2, CLR_YELLOW, CLR_RED )

      // all headers centered
      oBrw[ 6 ]:SetAlign( , 2, DT_CENTER )

      // vertical header in column 9
      oBrw[ 6 ]:SetAlign( 9, 2, DT_VERT )

      // adjust the header height
      oBrw[ 6 ]:nHeightHead := 25



   DbEval( { || If( Married, ++nMarried, ++nSingle ), nTotSal += Salary } )
   DbGotop()

   REDEFINE BROWSE oBrw[ 7 ] CELLED ALIAS "Employee" ;
      ID 110 OF oFld:aDialogs[ 7 ] ;
      FONT aFont[ 1 ]

      ADD COLUMN TO oBrw[ 7 ] ;
          HEADER "Index" ;
          DATA   oBrw[ 7 ]:nLogicPos ;
          SIZE 40 PIXELS ;
          FOOTER LTrim( Str( oBrw[ 7 ]:nLen ) ) ;
          3DLOOK TRUE,TRUE,FALSE ;  // cels, header, footer
          ALIGN DT_CENTER,DT_CENTER,DT_CENTER ;   // cells, header, footer
          COLORS CLR_BLACK, CLR_HGRAY

      // building columns for every field making each editable (.T.)
      oBrw[ 7 ]:LoadFields( .T. )

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_WHITE, CLR_GRAY } )    // footers
      oBrw[ 7 ]:SetColor( { 5, 6, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             CLR_BLACK } )        // grid lines

      oBrw[ 7 ]:SetColor( { CLR_EDITF, CLR_EDITB }, { CLR_BLACK, CLR_HGRAY } )  // Edicion

      // activating footers
      oBrw[ 7 ]:lFooting := .T.

      // freezing up to column 2
      oBrw[ 7 ]:nFreeze := 2

      // blocking frozen columns
      oBrw[ 7 ]:lLockFreeze := .T.

      // avoid edition of columns 2 and 3
      oBrw[ 7 ]:aColumns[ 2 ]:lEdit := .F.
      oBrw[ 7 ]:aColumns[ 3 ]:lEdit := .F.

      // changing colors to a single cell
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_WHITE, { || If( Married, ;        
                           CLR_HRED, CLR_NBLUE ) } }, 9 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_BLACK, ;
                          { || If( Age >= 60, ;
                           CLR_HRED, CLR_HGREEN ) } }, 10 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                                     { || If( Salary > 50000,CLR_HGREEN, ;
                                         If( Salary > 10000,CLR_HRED, ;
                                             CLR_RED ) ) } }, 11 )

      // changing background color of cells of column 12
      oBrw[ 7 ]:SetColor( { 2 }, { { CLR_YELLOW, CLR_BLACK } }, 12 ) // degraded color

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_BLACK, aBrush[ 2 ] } )  // brushed Footers background

      oBrw[ 7 ]:SetColor( { 5, 6, 4, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             aBrush[ 2 ], ; // brushed headers background
                                             CLR_BLACK } )  // grid lines

      // setting footers to columns 2, 8, 9, 11 y 12 using multi-line feature
      oBrw[ 7 ]:aColumns[ 2 ]:cFooting := "<-Total" + CRLF + "   Records"
      oBrw[ 7 ]:aColumns[ 8 ]:cFooting := "Married->" + CRLF + "Single->"
      oBrw[ 7 ]:Acolumns[ 9 ]:cFooting := { || LTrim( Str( nMarried ) ) + " T" + CRLF + ;
                                               LTrim( Str( nSingle ) ) + " F"}
      oBrw[ 7 ]:Acolumns[ 11 ]:cFooting := { || LTrim( Transform( nTotSal, ;
                                                "$##,###,###" ) ) }
      oBrw[ 7 ]:Acolumns[ 12 ]:cFooting := "<--Look at the font size."

      // changing footer font of column 11
      oBrw[ 7 ]:ChangeFont( aFont[ 3 ], 11, 3 )  // 3 = footer

      // centering text of column 9, all levels
      oBrw[ 7 ]:SetAlign( 9, , DT_CENTER )  // SetAlign( nColumn, nLevel, nAlign )

      // calculating vars value for footings
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 7 ]:aColumns[ 9 ]:bPostEdit := ;
                { | uVal | If( oBrw[ 7 ]:lChanged, ;
                           ( If( uVal, ( --nSingle, ++nMarried ), ;
                                     ( ++nSingle, --nMarried ) ), ;
                                       oBrw[ 7 ]:DrawFooters() ), ) }

      oBrw[ 7 ]:aColumns[ 11 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldSal := uVal, .T. ) }
      oBrw[ 7 ]:aColumns[ 11 ]:bPostEdit := ;
                { | uVal | nTotSal += ( uVal - nOldSal ), ;
                           If( oBrw[ 7 ]:lChanged, oBrw[ 7 ]:DrawFooters(), ) }
                         
      // changing header colors of columns from 9 to 11
      For nEle := 9 TO 11
         oBrw[ 7 ]:SetColor( { 3, 4 }, { CLR_WHITE, CLR_GRAY }, nEle )
      Next   

      // increasing cells height
      oBrw[ 7 ]:nHeightCell += 3

      // changing headings to columns 3 and 8 using multi-line
      oBrw[ 7 ]:aColumns[ 3 ]:cHeading := "Last" + CRLF + "Name"
      oBrw[ 7 ]:aColumns[ 8 ]:cHeading := "Hire" + CRLF + "Date"

      // another fancy use of BtnGet (Combo Browse)
      oBrw[ 7 ]:SetBtnGet( 6, "Help16", { | oGet, cVar | ;
                 aRect := GetCoors( oGet:hWnd ), cVar := oGet:Value(), ;
                 cVar := ComboBrowse( cVar, aRect[ 1 ], aRect[ 4 ], oGet:oWnd ), ;
                 oGet:cText( cVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )


   REDEFINE BUTTON ID 210 OF oDlg ACTION oDlg:End()

   ACTIVATE DIALOG oDlg CENTERED ;
            VALID ( oBmp:End(), .T. )

Return Nil

//----------------------------------------------------------------------------//

Static Function fWindow( nSample )

   Local oDlg, oBar, oFld, oBmp, oBrw[ 7 ],  oCol, aRect, nEle, nBrwHeight, ;
         nMarried := 0, ;
         nSingle  := 0, ;
         nTotSal  := 0, ;
         nAgeTot  := 0, ;
         nOldAge  := 0, ;
         nOldSal  := 0, ;
         aStates  := {}

   Field First, Last, Married, Age, Salary, State

IF aWChild[ nSample ] == Nil

   DEFINE BITMAP oBmp RESOURCE "Head"

   DEFINE WINDOW aWChild[ nSample ] OF oWnd NOBORDER NOMINIMIZE NOMAXIMIZE ;
          TITLE "Sample " + LTrim( Str( nSample ) ) ;
          FROM 0,0 TO oWnd:nBottom, oWnd:nRight PIXEL ;
          ICON oIco ;
          MDICHILD

   DEFINE BUTTONBAR oBar OF aWChild[ nSample ] SIZE 25,25 _3D  

   DEFINE BUTTON OF oBar NOBORDER
   DEFINE BUTTON OF oBar RESOURCE "Print16" NOBORDER;
          ACTION oBrw[ nSample ]:Report() ;
          TOOLTIP "Print"

   DEFINE BUTTON OF oBar RESOURCE "Exitb16" NOBORDER;
          ACTION aWChild[ nSample ]:End() ;
          TOOLTIP "Exit"

   aRect := GetClientRect( aWChild[ nSample ]:hWnd )

   nBrwHeight := aRect[ 3 ] - 36 - oBar:nHeight() - oWnd:oMsgBar:nHeight() - ;
                 oWnd:oBar:nHeight()

   DO Case

      Case nSample = 1


   @25, 1 BROWSE oBrw[ 1 ]  ALIAS "Employee" ;
         COLORS CLR_BLACK, CLR_NBLUE ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "Cell height idependent of the font size using oBrw:nHeightCell. " +;
                 "Also try multi-select feature by double clicking."

      oBrw[ 1 ]:LoadFields( .F. )

      oBrw[ 1 ]:SetColor( { 1, 3, 5, 6, 13, 15 }, ;
                          { CLR_BLACK, CLR_WHITE, CLR_BLACK, ;
                            { CLR_WHITE, CLR_BLACK }, ; // degraded cursor background color
                            CLR_WHITE, CLR_BLACK } )  // text colors
      oBrw[ 1 ]:SetColor( { 2, 4, 14 }, ;
                          { { CLR_WHITE, CLR_NBLUE }, ;  // degraded cells background color
                            { CLR_WHITE, CLR_BLACK }, ;  // degraded headers backgroud color
                            { CLR_HRED, CLR_BLACK } } )  // degraded order column background color

      oBrw[ 1 ]:nHeightCell += 6
      oBrw[ 1 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 1 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // vertical header in columns 8 y 9
      oBrw[ 1 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 1 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 1 ]:SetColSize( 8, 25)
      oBrw[ 1 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 1 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 1 ]:aColumns[ 5 ]:cOrder := "State"

      // degraded colors look better without horizontal lines
      oBrw[ 1 ]:nLineStyle := LINES_VERT



      Case nSample = 2

   DbSelectArea( "Sta" )
   DbEval( { || AAdd(aStates, State ) } )
   DbSelectArea( "Employee" )

   @25,1 BROWSE oBrw[ 2 ] CELLED ALIAS "Employee" ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "Auto-Append pressing down arrow at last row using" + ;
                 "::SetAppendMode( .T. )"

     oBrw[ 2 ]:LoadFields( .T. )
     oBrw[ 2 ]:nFreeze := 1
     oBrw[ 2 ]:SetAppendMode( .T. )

     // flagging columns that affect index key to issue UpStable() when fields change
     oBrw[ 2 ]:SetIndexCols( 1, 2 )

     oBrw[ 2 ]:Look3d( .T., , , .F. )  // ( lOnOff, nColumn, nLevel, lPhantomGrid )

     oBrw[ 2 ]:SetColor( { 1, 2, 3, 4, 5, 6, 15 }, ;
                         { CLR_WHITE, aBrush[ 4 ], CLR_WHITE, aBrush[ 5 ], ;
                           CLR_BLACK, nRGB( 236, 160, 19 ), CLR_BLACK } )

     // changing colors to column 2
     oBrw[ 2 ]:SetColor( { 1, 2 }, { CLR_BLACK, CLR_WHITE }, 2 )

     oBrw[ 2 ]:InsColumn( 8, OClone( oBrw[ 2 ]:aColumns[ 8 ] ) )

     // Windings font for happy/unhappy face
     oBrw[ 2 ]:aColumns[ 9 ]:bData := { | x | If( Married, "L", "J" ) }

     // avoid edition of column 9
     oBrw[ 2 ]:aColumns[ 9 ]:lEdit := .F.

     // we don't want empty names
     oBrw[ 2 ]:aColumns[ 1 ]:bValid := { | uVar | ! Empty( uVar ) }
     oBrw[ 2 ]:aColumns[ 2 ]:bValid := { | uVar | ! Empty( uVar ) }

     // Changing alignment to cells of columns 8 and 9
     oBrw[ 2 ]:SetAlign( 8, 1, DT_CENTER )   // ( nCol, nLevel, nAlign )
     oBrw[ 2 ]:SetAlign( 9, 1, DT_CENTER )   // nLevel 1=Cell, 2=Header, 3=Footer

     // now, setting a font to a single column
     oBrw[ 2 ]:ChangeFont( aFont[ 2 ], 9, 1 )   // 9 = column  1 = Nivel Celdas

     // next, setting colors at cell level for columns 9, 10 and 11
     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Married, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 9 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { CLR_BLACK, { || If( Age > 60, CLR_HRED, CLR_HGREEN ) }, ;
                           CLR_WHITE, CLR_BLACK }, 10 )

     oBrw[ 2 ]:SetColor( { 1, 2, 5, 6 }, ;
                         { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                           { || If( Salary > 50000,CLR_HGREEN, ;
                                If( Salary > 10000,CLR_HRED, ;
                                    CLR_RED ) ) }, ;
                           CLR_WHITE, CLR_BLACK }, 11 )

     // setting bData and related table for showing the combobox use at column 4
     oBrw[ 2 ]:SetData( 5, FieldWBlock( "State", Select() ), aStates )

     // changing the width of columns 5 and 7 to fit the ComboBox and the BtnGet
     oBrw[ 2 ]:SetColSize( 5, 130 )  // SetColSize( nColumn, nWidth )
     oBrw[ 2 ]:SetColSize( 7, 85 )

     // now changing the width of columns 8, 9 and 10 to fit new font
     oBrw[ 2 ]:SetColSize( { 8, 9, 10 }, { 55, 55, 40 } )  // ( aColumn, aWidth )

     // setting font aFont[ 4 ] to every header
     oBrw[ 2 ]:ChangeFont( aFont[ 4 ],,2 )  // ( aFont[ 1 ], nCol, nLevel )

     // activating BtnGet to column  7
     oBrw[ 2 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                 dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                 oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )
     


      Case nSample = 3


   @25,1 BROWSE oBrw[ 3 ] ALIAS "Employee" ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] ;
         MESSAGE 'Double Click on headers "Name" or "State" to stablish ' + ;
                 'the active index for incremental search.'

      oBrw[ 3 ]:LoadFields()

      oBrw[ 3 ]:SetColor( { 1, 3, 5, 13 }, { CLR_BLACK, CLR_BLACK, CLR_BLACK, ;
                                             CLR_BLACK } )

      // new degraded colors and brushed background
      oBrw[ 3 ]:SetColor( { 2, 4, 6, 12, 14 }, { aBrush[ 1 ], ;  // brushed cells
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded headers
                          { CLR_WHITE, CLR_NBROWN }, ;  // degraded cursor
                          { CLR_HRED, CLR_BLACK }, ;    // degraded selected cells
                          { CLR_HGREEN, CLR_BLACK } } ) // degraded active index header

      oBrw[ 3 ]:nHeightCell += 6
      oBrw[ 3 ]:nHeightHead += 4

      // activating Multi Selection
      oBrw[ 3 ]:SetSelectMode( .T., { | oBrw, nI, lSel | ;
                               MsgInfo( "Record " + Ltrim( Str( nI ) ) + ;
                                        If( lSel, " Selected", " Unselected" ) ) } )

      // brushing browse background
      oBrw[ 3 ]:oBrush := aBrush[ 1 ]

      // vertical header in columns 8 y 9
      oBrw[ 3 ]:SetAlign( 8, 2, DT_VERT )
      oBrw[ 3 ]:SetAlign( 9, 2, DT_VERT )

      // changing width of columns 8 y 9
      oBrw[ 3 ]:SetColSize( 8, 25)
      oBrw[ 3 ]:SetColSize( 9, 25)

      // activating incremental search with two tags in columns 1 and 5
      oBrw[ 3 ]:aColumns[ 1 ]:cOrder := "Name"
      oBrw[ 3 ]:aColumns[ 5 ]:cOrder := "State"

      // 3D text raised in all levels and all columns
      oBrw[ 3 ]:Set3DText( .T., .T. )



      Case nSample = 4

   DbEval( { || nAgeTot += Age } )
   DbGotop()

   @25,1 BROWSE oBrw[ 4 ] GRID ALIAS "Employee" ;
         COLORS CLR_BLACK,CLR_PINK ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "Fonts, colors and bitmaps different for cells, headers and footers"

      ADD COLUMN TO oBrw[ 4 ];
          HEADER  oBmp ;
          SIZE 130 ;
          DATA FieldWBlock( "First", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          ALIGN DT_LEFT, DT_CENTER ;
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Last" + CRLF + "Name" ;  // multi-line feature on headers
          DATA FieldWblock( "Last", Select() ) ;
          VALID { | uVar | ! Empty( uVar ) } ;  // don't want empty names
          COLORS CLR_BLACK, { CLR_PINK, CLR_BLACK } ; // degraded background color
          3DLOOK TRUE ;
          ALIGN DT_LEFT, DT_LEFT, DT_RIGHT ;
          FOOTER "Average->" ;
          EDITABLE MOVE DT_MOVE_RIGHT

      // next column shows the Vertical Header and Check Box editing control
      ADD COLUMN TO oBrw[ 4 ];
          HEADER "Married" ;
          SIZE 25 PIXELS ; 
          DATA FieldWblock( "Married", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          3DLOOK TRUE CHECKBOX ;          // Editing with Check Box
          ALIGN DT_CENTER, DT_VERT ;      // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Age" ;
          SIZE 32 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Age", Select() ) ;
          COLORS CLR_BLACK, CLR_PINK ;
          FOOTER { || Ltrim( Str( Round( nAgeTot / oBrw[ 4 ]:nLen, 0 ) ) ) + CRLF + ;
                      "Years" } ;  // multi-line feature on footers
          ALIGN DT_CENTER, DT_VERT ;  // Cells centered, Header Vertical
          EDITABLE MOVE DT_MOVE_RIGHT 

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Salary" ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Salary", Select() ) ;
          COLORS CLR_BLACK,CLR_NBLUE ;
          ALIGN DT_RIGHT ;  // defaults right alignment at 3 levels
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Hire" + CRLF + "Date" ;   // multi-line feature on headers
          SIZE 85 PIXELS ;
          3DLOOK TRUE;
          DATA FieldWBlock( "Hiredate", Select() ) ;
          ALIGN DT_LEFT, DT_CENTER, DT_CENTER ;
          COLORS CLR_BLACK,CLR_PINK ;
          EDITABLE MOVE DT_MOVE_NEXT

      ADD COLUMN TO oBrw[ 4 ] ;
          HEADER "Address" ;
          SIZE 270 PIXELS ;
          3DLOOK TRUE ;
          DATA { || oBrw[ 4 ]:Proper( Employee->Street ) + CRLF + ;
                    Trim( Employee->Zip ) + Space( 1 ) + ;
                    oBrw[ 4 ]:Proper( Trim( Employee->City ) ) + ", " + ;
                    State } ;  // multi-line feature on cells
          COLORS CLR_BLACK,CLR_PINK

      oBrw[ 4 ]:lNoHScroll := .T.
      oBrw[ 4 ]:nHeightCell += 2
      oBrw[ 4 ]:nHeightHead += 3

      // setting font to column 2 at all levels (Nil)
      oBrw[ 4 ]:ChangeFont( aFont[ 4 ], 2, Nil )  // (aFont[ 1 ], nColumn, nLevel)

      oBrw[ 4 ]:SetColor({ 5, 6 },{ CLR_WHITE, CLR_BLACK } ) // cursor background
      oBrw[ 4 ]:SetColor({ 5 },{ CLR_RED }, 2 )  // cursor background column 2
      oBrw[ 4 ]:aColumns[ 2 ]:cMsg := "A different font for each column."

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 4 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column 5
      oBrw[ 4 ]:SetBtnGet( 6, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      // managing var value for footing of column 3
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 4 ]:aColumns[ 4 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldAge := uVal, .T. ) }
      oBrw[ 4 ]:aColumns[ 4 ]:bPostEdit := ;
                { | uVal | nAgeTot += ( uVal - nOldAge ), ;
                           If( oBrw[ 4 ]:lChanged, oBrw[ 4 ]:DrawFooters(), ) }

      // 3D text bas-relief in all headers
      oBrw[ 4 ]:Set3DText( .T., .F.,, 2 )

      // 3D text raised in cells of column 2
      oBrw[ 4 ]:Set3DText( .T., .T., 2, 1 )



      Case nSample = 5



   @25,1 BROWSE oBrw[ 5 ]  COLORS CLR_BLACK,CLR_YELLOW;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "oBrw:lNoHScroll, eliminates horizontal scroll bar."

      // Setting the text file for viewing
      oBrw[ 5 ]:SetTxtFile( "TSBrowse.ch", ;
                            "TSBrowse Text Viewer" )

      // we don't want any cursor
      oBrw[ 5 ]:lNoLiteBar := .T.

      // we don't want horizontal scroll bar
      oBrw[ 5 ]:lNoHScroll := .T.

      // neither grid lines
      oBrw[ 5 ]:nLineStyle := LINES_NONE

      // setting font aFont[ 1 ] to every header
      oBrw[ 5 ]:ChangeFont( aFont[ 1 ],, 2 )  // ChangeFont( aFont[ 1 ], nColumn, nLevel ) 
                                         // nLevel 1 = Cells 2= Headers  3 = Footers

      // brushing cells background
      oBrw[ 5 ]:SetColor( { 2, 4 }, { aBrush[ 7 ], aBrush[ 3 ] } )

      // brushing browse background
      oBrw[ 5 ]:oBrush := aBrush[ 7 ]

      oBrw[ 5 ]:nHeightCell := 20



      Case nSample = 6

   DbSelectArea( "Sta" )
   DbEval( { || AAdd(aStates, State ) } )
   DbSelectArea( "Employee" )

   @25,1 BROWSE oBrw[ 6 ]  GRID ALIAS "Employee" ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL ;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "oBrw:LoadFields(), creates columns for every field in the active DB."

      oBrw[ 6 ]:LoadFields( .T. )
      oBrw[ 6 ]:nLineStyle := LINES_DOTTED 
      oBrw[ 6 ]:nHeightCell += 6
      oBrw[ 6 ]:nHeightHead += 4
      oBrw[ 6 ]:SetColor( { 2, 3, 4, 5, 6, 15 }, ;
                          { { || If( oBrw[ 6 ]:nLogicPos % 2 = 0, ;
                             aBrush[ 2 ], aBrush[ 1 ] ) }, ; // brushed cells
                           CLR_BLACK, aBrush[ 6 ], ; // brushed headers
                           CLR_WHITE, { CLR_WHITE, CLR_BLACK }, ; // degraded cursor
                           CLR_GRAY } )  // grid lines color

      // activating continuous editing mode
      oBrw[ 6 ]:lAutoEdit := .T.

      // interchanging positions between columns 4 and 5
      oBrw[ 6 ]:Exchange( 4, 5 )

      // changing the width of columns 4 and 7 to fit the ComboBox and the BtnGet
      oBrw[ 6 ]:SetColSize( 4, 130 )  // ( nColumn, nWidth )
      oBrw[ 6 ]:SetColSize( 7, 80 )

      // setting bData and related table for showing the combobox use at column 4
      oBrw[ 6 ]:SetData( 4, FieldWBlock( "State", Select() ), aStates )

      // flagging columns that affect index key to issue UpStable() when fields change
      oBrw[ 6 ]:SetIndexCols( 1, 2 )

      // activating BtnGet to column  7
      oBrw[ 6 ]:SetBtnGet( 7, "Calen16", { | oGet, dVar | aRect := GetCoors( oGet:hWnd ), ;
                  dVar := FwCalendar( oGet:Value(), aRect[ 1 ], aRect[ 4 ], oGet:oWnd ),;
                  oGet:cText( dVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      oBrw[ 6 ]:nLineStyle := LINES_VERT

      // 3D text raised in all headers, special colors for 3D effect
      oBrw[ 6 ]:Set3DText( .T., .T.,, 2, CLR_YELLOW, CLR_RED )

      // all headers centered
      oBrw[ 6 ]:SetAlign( , 2, DT_CENTER )

      // vertical header in column 9
      oBrw[ 6 ]:SetAlign( 9, 2, DT_VERT )

      // adjust the header height
      oBrw[ 6 ]:nHeightHead := 25



      Case nSample = 7

   DbEval( { || If( Married, ++nMarried, ++nSingle ), nTotSal += Salary } )
   DbGotop()

   @25,1 BROWSE oBrw[ 7 ] CELLED ALIAS "Employee" ;
         SIZE aRect[ 4 ], nBrwHeight PIXEL UPDATE;
         OF aWChild[ nSample ] FONT aFont[ 1 ] ;
         MESSAGE "oBrw:bPrevEdit and oBrw:bPostEdit, can control the footer's value." 

      ADD COLUMN TO oBrw[ 7 ] ;
          HEADER "Index" ;
          DATA   oBrw[ 7 ]:nLogicPos ;
          SIZE 40 PIXELS ;
          FOOTER LTrim( Str( oBrw[ 7 ]:nLen ) ) ;
          3DLOOK TRUE,TRUE,FALSE ;  // cels, header, footer
          ALIGN DT_CENTER,DT_CENTER,DT_CENTER ;   // cells, header, footer
          COLORS CLR_BLACK, CLR_HGRAY

      // building columns for every field making each editable (.T.)
      oBrw[ 7 ]:LoadFields( .T. )

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_WHITE, CLR_GRAY } )    // footers
      oBrw[ 7 ]:SetColor( { 5, 6, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             CLR_BLACK } )        // grid lines

      oBrw[ 7 ]:SetColor( { CLR_EDITF, CLR_EDITB }, { CLR_BLACK, CLR_HGRAY } )  // Edicion

      // activating footers
      oBrw[ 7 ]:lFooting := .T.

      // freezing up to column 2
      oBrw[ 7 ]:nFreeze := 2

      // blocking frozen columns
      oBrw[ 7 ]:lLockFreeze := .T.

      // avoid edition of columns 2 and 3
      oBrw[ 7 ]:aColumns[ 2 ]:lEdit := .F.
      oBrw[ 7 ]:aColumns[ 3 ]:lEdit := .F.

      // changing colors to a single cell
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_WHITE, { || If( Married, ;        
                           CLR_HRED, CLR_NBLUE ) } }, 9 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { CLR_BLACK, ;
                          { || If( Age >= 60, ;
                           CLR_HRED, CLR_HGREEN ) } }, 10 )
      oBrw[ 7 ]:SetColor( { 1, 2 }, { { || If( Salary < 10001, CLR_WHITE, CLR_BLACK ) } , ;
                                     { || If( Salary > 50000,CLR_HGREEN, ;
                                         If( Salary > 10000,CLR_HRED, ;
                                             CLR_RED ) ) } }, 11 )

      // changing background color of cells of column 12
      oBrw[ 7 ]:SetColor( { 2 }, { { CLR_YELLOW, CLR_BLACK } }, 12 ) // degraded color

      oBrw[ 7 ]:SetColor( { 9, 10 }, { CLR_BLACK, aBrush[ 2 ] } )  // brushed Footers background

      oBrw[ 7 ]:SetColor( { 5, 6, 4, 15 }, { CLR_WHITE, CLR_BLACK, ; // cursor
                                             aBrush[ 2 ], ; // brushed headers background
                                             CLR_BLACK } )  // grid lines

      // setting footers to columns 2, 8, 9, 11 y 12 using multi-line feature
      oBrw[ 7 ]:aColumns[ 2 ]:cFooting := "<-Total" + CRLF + "   Records"
      oBrw[ 7 ]:aColumns[ 8 ]:cFooting := "Married->" + CRLF + "Single->"
      oBrw[ 7 ]:Acolumns[ 9 ]:cFooting := { || LTrim( Str( nMarried ) ) + " T" + CRLF + ;
                                               LTrim( Str( nSingle ) ) + " F"}
      oBrw[ 7 ]:Acolumns[ 11 ]:cFooting := { || LTrim( Transform( nTotSal, ;
                                                "$##,###,###" ) ) }
      oBrw[ 7 ]:Acolumns[ 12 ]:cFooting := "<--Look at the font size."

      // changing footer font of column 11
      oBrw[ 7 ]:ChangeFont( aFont[ 3 ], 11, 3 )  // 3 = footer

      // centering text of column 9, all levels
      oBrw[ 7 ]:SetAlign( 9, , DT_CENTER )  // SetAlign( nColumn, nLevel, nAlign )

      // calculating vars value for footings
      // and showing the use of codeblocks bPrevEdit and bPostEdit
      oBrw[ 7 ]:aColumns[ 9 ]:bPostEdit := ;
                { | uVal | If( oBrw[ 7 ]:lChanged, ;
                           ( If( uVal, ( --nSingle, ++nMarried ), ;
                                     ( ++nSingle, --nMarried ) ), ;
                                       oBrw[ 7 ]:DrawFooters() ), ) }

      oBrw[ 7 ]:aColumns[ 11 ]:bPrevEdit := { | uVal | If( PCount() > 0, ;
                                               nOldSal := uVal, .T. ) }
      oBrw[ 7 ]:aColumns[ 11 ]:bPostEdit := ;
                { | uVal | nTotSal += ( uVal - nOldSal ), ;
                           If( oBrw[ 7 ]:lChanged, oBrw[ 7 ]:DrawFooters(), ) }
                         
      // changing header colors of columns from 9 to 11
      For nEle := 9 TO 11
         oBrw[ 7 ]:SetColor( { 3, 4 }, { CLR_WHITE, CLR_GRAY }, nEle )
      Next   

      // increasing cells height
      oBrw[ 7 ]:nHeightCell += 3

      // changing headings to columns 3 and 8 using multi-line
      oBrw[ 7 ]:aColumns[ 3 ]:cHeading := "Last" + CRLF + "Name"
      oBrw[ 7 ]:aColumns[ 8 ]:cHeading := "Hire" + CRLF + "Date"

      // another fancy use of BtnGet (Combo Browse)
      oBrw[ 7 ]:SetBtnGet( 6, "Help16", { | oGet, cVar | ;
                 aRect := GetCoors( oGet:hWnd ), cVar := oGet:Value(), ;
                 cVar := ComboBrowse( cVar, aRect[ 1 ], aRect[ 4 ], oGet:oWnd ), ;
                 oGet:cText( cVar ), oGet:Refresh(), oGet:KeyDown( VK_RETURN, 0 ) }, 16 )

      // editing message for column 6
      oBrw[ 7 ]:aColumns[ 6 ]:cMsg := "Press F2 or Click button to see the list"
      oBrw[ 7 ]:aActions := Array( Len( oBrw[ 7 ]:aColumns ) )
      oBrw[ 7 ]:aActions[ 2 ] := { ||msginfo( 2 ) }

   EndCase

   // oBrw:ShowSizes() a nice programmers tool
   oBrw[ nSample ]:bRClicked := { || oBrw[ nSample ]:ShowSizes() }

   // this is necessary when use the same data base in various MDI windows
   // to restore the record pointer as it was when browse lost focus
   oBrw[ nSample ]:lNoResetPos := .F.

   aWChild[ nSample ]:lDesign := .F.
   aWChild[ nSample ]:bGotFocus := {|| oBrw[ nSample ]:SetFocus() }

   ACTIVATE WINDOW aWChild[ nSample ] ;
            ON PAINT oBrw[ nSample ]:SetFocus();
            VALID ( aWChild[ nSample ] := Nil, oBmp:End(), .T. )


Else
   aWChild[ nSample ]:SetFocus()
EndIf

Return Nil

//--------------------------------------------------------------------------//

Static Function ComboBrowse( cState, nRow, nCol, oWnd )

   Local oDlg, oBrw, oFont, ;
         nArea := Select(), ;
         lOk   := .F.

   Default nRow := 0, ;
           nCol := 0

   DbSelectArea( "Sta" )

   If ! Dbseek( AllTrim( cState ) )
      DbGoTop()
   EndIf

   If ValType( oWnd ) = "O"

      oRect := oWnd:GetRect()

      If ValType( nRow ) = "N"
         nRow += oRect:nTop
         nCol += oRect:nLeft
      EndIf

      If ( nEle := ( GetSysMetrics( 1 ) - ( nRow + 254 ) ) ) < 0
         nRow += nEle
      EndIf

      If ( nEle := ( GetSysMetrics( 0 ) - ( nCol + 158 ) ) ) < 0
         nCol += nEle
      EndIf

   Else
      nRow := Nil
   EndIf

   DEFINE FONT oFont NAME "MS Sans Serif" SIZE 0, -10

   DEFINE DIALOG oDlg FROM nRow, nCol TO nRow + 197, nCol + 157 PIXEL ;
          STYLE nOr( WS_VISIBLE, WS_POPUP )

   @0,0 BROWSE oBrw ALIAS "Sta" OF oDlg SIZE 79, 99 PIXEL FONT oFont ;
        ON DBLCLICK ( lOk := .T., oDlg:End() ) ;
        COLORS CLR_WHITE, nRGB(128,0,255)

   ADD COLUMN TO oBrw TITLE "Code" DATA SubStr( Sta->State, 1, 2 ) ;
       SIZE 40 PIXELS ;
       COLORS CLR_WHITE, nRGB(128,0,255),,, CLR_WHITE, CLR_BLACK ;
       ORDER "States"

   ADD COLUMN TO oBrw TITLE "State" DATA SubStr( Sta->State, 3 ) ;
       SIZE 118 PIXELS ;
       COLORS CLR_WHITE, nRGB(128,0,255),,, CLR_WHITE, CLR_BLACK

   oBrw:bKeyDown := { | nKey | If( nKey == VK_RETURN .or. nKey == VK_ESCAPE, ;
                               oDlg:End(), Nil ), lOk := nKey != VK_ESCAPE }
   oBrw:lSeek       := .T.
   oBrw:lNoHScroll  := .T.
   oBrw:lNoResetPos := .T.
   oBrw:nLineStyle  := 0
   oBrw:SetColor( { 15 }, { CLR_BLACK } )

   ACTIVATE DIALOG oDlg ;
         ON PAINT ( If( ValType( nRow ) != "N", WndCenter( oDlg:hWnd ), ;
                    oDlg:Move( nRow, nCol ) ) ) ;
         VALID ( DbSelectarea( nArea ), oFont:End(), .T. )


Return If( lOk, SubStr( Sta->State, 1, 2 ), cState )
