/*
   SBMsgFre.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: FRE
   ISO Name...: French
   Translator.: Richard Chidiak <rcc@cbati.com>
   Country....: France
   Date.......: February 18th, 2002
*/

#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "Oui", ;                                    // ::aMsg[ 1 ]
                   "Non", ;                                    // ::aMsg[ 2 ]
                   "Enregistrement en cours d'utilisation", ;  // ::aMsg[ 3 ]
                   "Essayez encore", ;                         // ::aMsg[ 4 ]
                   OEMTOANSI("Enregistrement non ajout"), ;   // ::aMsg[ 5 ]
                   "&Annuler", ;              // ::aMsg[ 6 ]
                   "&Copier Colonne", ;       // ::aMsg[ 7 ]
                   "Co&uper Colonne", ;       // ::aMsg[ 8 ]
                   "Co&Ller Colonne", ;       // ::aMsg[ 9 ]
                   "&Supprimer Colonne", ;    // ::aMsg[ 10 ]
                   "Supprimer", ;             // ::aMsg[ 11 ]
                   "Copier", ;                // ::aMsg[ 12 ]
                   "Couper", ;                // ::aMsg[ 13 ]
                   OEMTOANSI("Dplacer vers le &bas"), ;        // ::aMsg[ 14 ]
                   OEMTOANSI("Dplacer  &droite"), ;           // ::aMsg[ 15 ]
                   OEMTOANSI("Dplacer vers le &haut"), ;       // ::aMsg[ 16 ]
                   OEMTOANSI("Dplacer  &gauche"), ;           // ::aMsg[ 17 ]
                   OEMTOANSI("Dplacer vers le suivant"), ;     // ::aMsg[ 18 ]
                   "Cu&rseur", ;              // ::aMsg[ 19 ]
                   "Date:", ;                 // ::aMsg[ 20 ]
                   "Page:", ;                 // ::aMsg[ 21 ]
                   "Heure:", ;                // ::aMsg[ 22 ]
                   OEMTOANSI("(Prvisualisation)"), ;    // ::aMsg[ 23 ]
                   "Colonne", ;               // ::aMsg[ 24 ]
                   "Partie visible", ;         // ::aMsg[ 25 ]
                   "Largeur Colonnes", ;      // ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() les Types ne correspondent pas au type d'index", ;
                   "Erreur", ;                // ::aMsg[ 28 ]
                   "Le fichier", ;            // ::aMsg[ 29 ]
                   "n'existe pas", ;          // ::aMsg[ 30 ]
                   "Largeur:", ;               // ::aMsg[ 31 ]
                   "Champs Memo", ;           // ::aMsg[ 32 ]
                   "Edition:", ;              // ::aMsg[ 33 ]
                   "&Accepter", ;             // ::aMsg[ 34 ]
                   "&Annuler", ;              // ::aMsg[ 35 ]
                   "Ai&de", ;                 // ::aMsg[ 36 ]
                   "Supprimer Enregistrement ?", ;       // ::aMsg[ 37 ]
                   "Supprimler Ligne ?", ;          // ::aMsg[ 38 ]
                   "Confirmer", ;               // ::aMsg[ 39 ]
                   OEMTOANSI("Enregistrement en cours d'utilisation, ne peut tre verrouill"), ;  // ::aMsg[ 40 ]
                   "Appuyez sur Echap pour annuler le mode Edition", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { " A ", ;    // ::aMsg[ 51 ]
                      " De ", ;    // ::aMsg[ 52 ]
                      " Dans ", ;    // ::aMsg[ 53 ]
                      " Et ", ;   // ::aMsg[ 54 ]
                      " Ou " }     // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
