/*
   SBMsgLit.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: LIT
   ISO Name...: Lithuanian
   Translator.: Rimantas Usevicius <urimas@takas.lt>
   Country....: Lithuania
   Date.......: February 21th, 2002
*/

#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "Taip", ;                  // ::aMsg[ 1 ]
                   "Ne", ;                    // ::aMsg[ 2 ]
                   "Irasas naudojamas", ;     // ::aMsg[ 3 ]
                   "Bandykit dar karta", ;    // ::aMsg[ 4 ]
                   "Irasas nepridetas", ;     // ::aMsg[ 5 ]
                   "Atstatyti", ;             // ::aMsg[ 6 ]
                   "Kopijuoti Stulpeli", ;    // ::aMsg[ 7 ]
                   "Iskirp&ti Stulpeli", ;    // ::aMsg[ 8 ]
                   "Atko&pijuoti Stulpeli", ; // ::aMsg[ 9 ]
                   "&Salinti Stulpeli", ;     // ::aMsg[ 10 ]
                   "Pasalinti", ;             // ::aMsg[ 11 ]
                   "Kopijuoti", ;             // ::aMsg[ 12 ]
                   "Iskirpti", ;              // ::aMsg[ 13 ]
                   "Judeti Zemyn", ;          // ::aMsg[ 14 ]
                   "Judeti Desinen", ;        // ::aMsg[ 15 ]
                   "Judeti Aukstyn", ;        // ::aMsg[ 16 ]
                   "Judeti Kairen", ;         // ::aMsg[ 17 ]
                   "Judeti i Sekanti", ;      // ::aMsg[ 18 ]
                   "Ku&rsorius", ;            // ::aMsg[ 19 ]
                   "Data:", ;                 // ::aMsg[ 20 ]
                   "Lapas:", ;                // ::aMsg[ 21 ]
                   "Laikas:", ;               // ::aMsg[ 22 ]
                   "(Isankst.vazdas)", ;      // ::aMsg[ 23 ]
                   "Stulpelis", ;             // ::aMsg[ 24 ]
                   "Matomas plotas", ;        // ::aMsg[ 25 ]
                   "Stulpelio plotis",        // ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() Nesutinka indekso ir reiksmes tipai", ;
                   "Klaida", ;                // ::aMsg[ 28 ]
                   "Byla", ;                  // ::aMsg[ 29 ]
                   "neegzistuoja", ;          // ::aMsg[ 30 ]
                   "Plotis:", ;               // ::aMsg[ 31 ]
                   "Memo Laukas", ;           // ::aMsg[ 32 ]
                   "Taisyti:", ;              // ::aMsg[ 33 ]
                   "Priimti", ;               // ::aMsg[ 34 ]
                   "Atsisakyti", ;            // ::aMsg[ 35 ]
                   "Pagalba", ;               // ::aMsg[ 36 ]
                   "Salinti Irasa ?", ;       // ::aMsg[ 37 ]
                   "Salinti Eilute ?", ;      // ::aMsg[ 38 ]
                   "Sutikti", ;               // ::aMsg[ 39 ]
                   "Irasas naudojamas, negalima uzblokuoti", ;  // ::aMsg[ 40 ]
                   "Spausti [Esc] atsisakyti redagavimo", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { " I ", ;       // ::aMsg[ 51 ]
                      " Is ", ;      // ::aMsg[ 52 ]
                      " I vidu ", ;  // ::aMsg[ 53 ]
                      " Ir ", ;      // ::aMsg[ 54 ]
                      " Arba " }     // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
