/*
   SBMsgCht.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: CHT
   ISO Name...: Chinese (Taiwan)
   Translator.: Wang Dongming <dongming@km169.net>
   Country....: Slovenia
   Date.......: February 18th, 2002
*/


#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "O", ;                 // ::aMsg[ 1 ]
                   "_", ;                 // ::aMsg[ 2 ]
                   "OϥΤ", ;         // ::aMsg[ 3 ]
                   "", ;               // ::aMsg[ 4 ]
                   "OSl[", ;       // ::aMsg[ 5 ]
                   "(&U)", ;           // ::aMsg[ 6 ]
                   "ƻsC(&C)", ;         // ::aMsg[ 7 ]
                   "ŤUC(&T)", ;         // ::aMsg[ 8 ]
                   "KWC(&P)", ;         // ::aMsg[ 9 ]
                   "RC(&D)", ;         // ::aMsg[ 10 ]
                   "R", ;               // ::aMsg[ 11 ]
                   "ƻs", ;               // ::aMsg[ 12 ]
                   "ŤU", ;               // ::aMsg[ 13 ]
                   "VU(&D)", ;       // ::aMsg[ 14 ]
                   "Vk(&R)", ;       // ::aMsg[ 15 ]
                   "VW(&U)", ;       // ::aMsg[ 16 ]
                   "V(&L)", ;       // ::aMsg[ 17 ]
                   "VU@Ӳ(&N)", ;   // ::aMsg[ 18 ]
                   "(&R)", ;           // ::aMsg[ 19 ]
                   ":", ;              // ::aMsg[ 20 ]
                   "X:", ;              // ::aMsg[ 21 ]
                   "ɶ:", ;              // ::aMsg[ 22 ]
                   "(w)", ;             // ::aMsg[ 23 ]
                   "C", ;                 // ::aMsg[ 24 ]
                   "i", ;             // ::aMsg[ 25 ]
                   "Ce", ;               // ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() Peǰt", ;
                   "~", ;               // ::aMsg[ 28 ]
                   "", ;               // ::aMsg[ 29 ]
                   "sb", ;             // ::aMsg[ 30 ]
                   "e:", ;              // ::aMsg[ 31 ]
                   "Ƶrq", ;           // ::aMsg[ 32 ]
                   "s:", ;              // ::aMsg[ 33 ]
                   "T{(&A)", ;           // ::aMsg[ 34 ]
                   "(&C)", ;           // ::aMsg[ 35 ]
                   "U(&H)", ;           // ::aMsg[ 36 ]
                   "RO ?", ;         // ::aMsg[ 37 ]
                   "R ?", ;           // ::aMsg[ 38 ]
                   "T{", ;               // ::aMsg[ 39 ]
                   "OϥΤAQw", ;  // ::aMsg[ 40 ]
                   " [Esc] sҦ", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { "    ", ;    // ::aMsg[ 51 ]
                      "    ", ;    // ::aMsg[ 52 ]
                      "    ", ;    // ::aMsg[ 53 ]
                      "     ", ;   // ::aMsg[ 54 ]
                      "    " }     // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
