/*
   SBMsgIta.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: ITA
   ISO Name...: Italian
   Translator.: Enrico Maria Giordano <e.m.giordano@emagsoftware.it>
   Country....: Italy
   Date.......: February 18th, 2002
*/

#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "Si", ;                    // ::aMsg[ 1 ]
                   "No", ;                    // ::aMsg[ 2 ]
                   "Record In uso", ;         // ::aMsg[ 3 ]
                   "Riprova", ;               // ::aMsg[ 4 ]
                   "Record Non Aggiunto", ;   // ::aMsg[ 5 ]
                   "&Annulla", ;              // ::aMsg[ 6 ]
                   "&Copia Colonna", ;        // ::aMsg[ 7 ]
                   "&Taglia Colonna", ;       // ::aMsg[ 8 ]
                   "&Incolla Colonna", ;      // ::aMsg[ 9 ]
                   "Ca&ncella Colonna", ;     // ::aMsg[ 10 ]
                   "Cancella", ;              // ::aMsg[ 11 ]
                   "Copia", ;                 // ::aMsg[ 12 ]
                   "Taglia", ;                // ::aMsg[ 13 ]
                   "Sposta in &Basso", ;      // ::aMsg[ 14 ]
                   "Sposta a &Destra", ;      // ::aMsg[ 15 ]
                   "Sposta in &Alto", ;       // ::aMsg[ 16 ]
                   "Sposta a &Sinistra", ;    // ::aMsg[ 17 ]
                   "Vai al &Prossimo", ;      // ::aMsg[ 18 ]
                   "Cu&rsore", ;              // ::aMsg[ 19 ]
                   "Data:", ;                 // ::aMsg[ 20 ]
                   "Pagina:", ;               // ::aMsg[ 21 ]
                   "Ora:", ;                  // ::aMsg[ 22 ]
                   "(Anteprima)", ;           // ::aMsg[ 23 ]
                   "Colonna", ;               // ::aMsg[ 24 ]
                   "Area Visibile", ;         // ::aMsg[ 25 ]
                   "Larghezza Colonna", ;     // ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() Tipi non corrispondenti alla chiave dell'indice corrente", ;
                   "Errore", ;                // ::aMsg[ 28 ]
                   "Il file", ;               // ::aMsg[ 29 ]
                   "non esiste", ;            // ::aMsg[ 30 ]
                   "Larghezza:", ;            // ::aMsg[ 31 ]
                   "Campo Memo", ;            // ::aMsg[ 32 ]
                   "Modifica:", ;             // ::aMsg[ 33 ]
                   "&Conferma", ;             // ::aMsg[ 34 ]
                   "&Annulla", ;              // ::aMsg[ 35 ]
                   "A&iuto", ;                // ::aMsg[ 36 ]
                   "Cancello il Record ?", ;  // ::aMsg[ 37 ]
                   "Cancello la Riga ?", ;    // ::aMsg[ 38 ]
                   "Conferma", ;              // ::aMsg[ 39 ]
                   "Record in uso, impossibile bloccare", ;  // ::aMsg[ 40 ]
                   "Premi [Esc] per uscire dalla fase di modifica", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { " A ", ;    // ::aMsg[ 51 ]
                      " Di ", ;    // ::aMsg[ 52 ]
                      " In ", ;    // ::aMsg[ 53 ]
                      " Y ", ;   // ::aMsg[ 54 ]
                      " O " }     // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
