/*
   SBMsgPol.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: POL
   ISO Name...: Polish
   Translator.: Marcin Patek <marcinplatek@wp.pl>
   Country....: Poland
   Date.......: February 22th, 2002
*/

#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "Tak", ;                   // ::aMsg[ 1 ]
                   "Nie", ;                   // ::aMsg[ 2 ]
                   "Rekord zablokowany", ;    // ::aMsg[ 3 ]
                   "Ponw", ;                 // ::aMsg[ 4 ]
                   "Nie doczono rekordu", ; // ::aMsg[ 5 ]
                   "Odtwrz", ;               // ::aMsg[ 6 ]
                   "Kopiuj column", ;        // ::aMsg[ 7 ]
                   "Usu kolumn", ;          // ::aMsg[ 8 ]
                   "Wklej kolumn", ;         // ::aMsg[ 9 ]
                   "Kasuj kolumn", ;         // ::aMsg[ 10 ]
                   "Kasuj", ;                 // ::aMsg[ 11 ]
                   "Kopiuj", ;                // ::aMsg[ 12 ]
                   "Wytnij", ;                // ::aMsg[ 13 ]
                   "Na d", ;                // ::aMsg[ 14 ]
                   "W prawo", ;               // ::aMsg[ 15 ]
                   "W gr", ;                // ::aMsg[ 16 ]
                   "W lewo", ;                // ::aMsg[ 17 ]
                   "Nastpna pozycja", ;      // ::aMsg[ 18 ]
                   "Kursor", ;                // ::aMsg[ 19 ]
                   "Data:", ;                 // ::aMsg[ 20 ]
                   "Strona:", ;               // ::aMsg[ 21 ]
                   "Czas:", ;                 // ::aMsg[ 22 ]
                   "(Podgld)", ;             // ::aMsg[ 23 ]
                   "Kolumna", ;               // ::aMsg[ 24 ]
                   "Obszar widoczny", ;       // ::aMsg[ 25 ]
                   "Dugo kolumny", ;       // ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() Typ niezgodny z aktualnym kluczem indeksowym", ;
                   "Bd", ;                  // ::aMsg[ 28 ]
                   "Zbir", ;                 // ::aMsg[ 29 ]
                   "nie istnieje", ;          // ::aMsg[ 30 ]
                   "Dugo:", ;              // ::aMsg[ 31 ]
                   "Pole memo", ;             // ::aMsg[ 32 ]
                   "Edycja:", ;               // ::aMsg[ 33 ]
                   "&Akceptuj", ;             // ::aMsg[ 34 ]
                   "&Odrzu", ;               // ::aMsg[ 35 ]
                   "&Pomoc", ;                // ::aMsg[ 36 ]
                   "Kasuj rekord ?", ;        // ::aMsg[ 37 ]
                   "Kasuj wiersz ?", ;        // ::aMsg[ 38 ]
                   "Potwierd", ;             // ::aMsg[ 39 ]
                   "Rekord zajty, brak moliwoci zablokowania", ;  // ::aMsg[ 40 ]
                   "Nacinij [Esc] aby przerwa edycj", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { " Do ", ;    // ::aMsg[ 51 ]
                      " Z ", ;     // ::aMsg[ 52 ]
                      " W ", ;     // ::aMsg[ 53 ]
                      " I ", ;     // ::aMsg[ 54 ]
                      " Lub " }    // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
