/*
   SBMsgSlo.prg
   Program to load messages for TSBrowse Multi-Lingual feature
   Author: Manuel Mercado

   Language ID: SLO
   ISO Name...: Slovak
   Translator.: Lojze Kavzek <lojze@marpol.si>
   Country....: Slovenia
   Date.......: February 18th, 2002
*/

#include "FiveWin.ch"

//--------------------------------------------------------------------------//

Function LoadMsg()

   Local nEle

   Local aMsg := { "Da", ;                    	// ::aMsg[ 1 ]
                   "Ne", ;                    	// ::aMsg[ 2 ]
                   "Zapis zaseden", ;         	// ::aMsg[ 3 ]
                   "Ponovi", ;                	// ::aMsg[ 4 ]
                   "Zapis ni dodan", ;   	// ::aMsg[ 5 ]
                   "&Razveljavi", ;             // ::aMsg[ 6 ]
                   "&Kopiraj Kolono", ;         // ::aMsg[ 7 ]
                   "Izrei& Kolono", ;          // ::aMsg[ 8 ]
                   "&Prilepi Kolono", ;         // ::aMsg[ 9 ]
                   "&Brii Kolono", ;        	// ::aMsg[ 10 ]
                   "Brii", ;                	// ::aMsg[ 11 ]
                   "Kopiraj", ;                 // ::aMsg[ 12 ]
                   "Izrei", ;                  // ::aMsg[ 13 ]
                   "Premik &Dol", ;            	// ::aMsg[ 14 ]
                   "Premik D&esno", ;           // ::aMsg[ 15 ]
                   "Premik &Gor", ;             // ::aMsg[ 16 ]
                   "Premik &Levo", ;            // ::aMsg[ 17 ]
                   "Premik &Naslednji", ;       // ::aMsg[ 18 ]
                   "Kazal&o", ;               	// ::aMsg[ 19 ]
                   "Datum:", ;                 	// ::aMsg[ 20 ]
                   "Stran:", ;                 	// ::aMsg[ 21 ]
                   "Ura:", ;                 	// ::aMsg[ 22 ]
                   "(Pred Ogled)", ;            // ::aMsg[ 23 ]
                   "Kolona", ;                	// ::aMsg[ 24 ]
                   "Vidno obmoje", ;         	// ::aMsg[ 25 ]
                   "irina kolon", ;         	// ::aMsg[ 26 ]
                   "Tsbrowse SetFilter() - tip polja filtra se ne ujema s tipom kljua indeksa", ;
                   "Napaka", ;                 	// ::aMsg[ 28 ]
                   "Datoteka", ;              	// ::aMsg[ 29 ]
                   "Ne obstaja", ;         	// ::aMsg[ 30 ]
                   "irina:", ;                	// ::aMsg[ 31 ]
                   "Memo Polje", ;            	// ::aMsg[ 32 ]
                   "Urejanje:", ;              	// ::aMsg[ 33 ]
                   "Potr&di", ;               	// ::aMsg[ 34 ]
                   "Pre&kini", ;               	// ::aMsg[ 35 ]
                   "P&omo", ;                 	// ::aMsg[ 36 ]
                   "Briem zapis ?", ;       	// ::aMsg[ 37 ]
                   "Briem vrsto?", ;          	// ::aMsg[ 38 ]
                   "Potrdite", ;               	// ::aMsg[ 39 ]
                   "Zapis zaseden, zaklepanje ni uspelo", ;  // ::aMsg[ 40 ]
                   "[Esc] za prekinitev urejanja polja", ; // ::aMsg[ 41 ]
                   "", ;    // ::aMsg[ 42 ] (future posible ussage)
                   "", ;    // ::aMsg[ 43 ]
                   "", ;    // ::aMsg[ 44 ]
                   "", ;    // ::aMsg[ 45 ]
                   "", ;    // ::aMsg[ 46 ]
                   "", ;    // ::aMsg[ 47 ]
                   "", ;    // ::aMsg[ 48 ]
                   "", ;    // ::aMsg[ 49 ]
                   "" }     // ::aMsg[ 50 ]

   // some conjunctions and prepositions for TSBrowse:Proper() method
   // keep spaces and capitals
   Local aProper := { " Za  ", ;    // ::aMsg[ 51 ]
                      " Od  ", ;    // ::aMsg[ 52 ]
                      " V   ", ;    // ::aMsg[ 53 ]
                      " In  ", ;   // ::aMsg[ 54 ]
                      " Ali " }     // ::aMsg[ 55 ]

   AEval( aProper, { |e| AAdd( aMsg, e ) } )

   For nEle := 1 To Len( aMsg )
       aMsg[ nEle ] := OemToAnsi( aMsg[ nEle ] )
   Next

Return aMsg
