#include "FiveWin.ch"

#define VK_CTRL_W   23

* ============================================================================
* CLASS TSMulti  Version 6.0 Apr/5/2002
* ============================================================================

CLASS TSMulti FROM TMultiGet

   Method KeyChar( nKey, nFlags )
   Method KeyDown( nKey, nFlags )
   Method lValid()

ENDCLASS

* ============================================================================
* METHOD TSMulti:KeyChar() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyChar( nKey, nFlags ) CLASS TSMulti

   ::nLastKey = nKey

   If nKey == VK_TAB .or. nKey == VK_CTRL_W
      If ::lValid()

         If ::bKeyDown != Nil
            Eval( ::bKeyDown, nKey, nFlags)
         Endif

         ::oWnd:GoNextCtrl( ::hWnd )

      EndIf

      Return 0
   Endif

RETURN Super:KeyChar( nKey, nFlags )

* ============================================================================
* METHOD TSMulti:KeyDown() Version 6.0 Apr/5/2002
* ============================================================================

METHOD KeyDown( nKey, nFlags ) CLASS TSMulti

   ::nLastKey = nKey

   If nKey == VK_TAB .or. nKey == VK_CTRL_W
      If ::lValid()

         If ::bKeyDown != Nil
            Eval( ::bKeyDown, nKey, nFlags)
         Endif

         ::Destroy()

      EndIf

      Return 0
   Else
      MsgInfo(nKey)
   Endif

RETURN Super:KeyDown( nKey, nFlags )

* ============================================================================
* METHOD TSMulti:lValid() Version 6.0 Apr/5/2002
* ============================================================================

METHOD lValid() CLASS TSMulti

   Local lRet := .t.

   If ValType( ::bValid ) == "B"
      lRet := Eval( ::bValid, ::GetText() )
   EndIf

Return lRet

